%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=0;


%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
real_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AP2568');
%comp_assets=xlsread('JSTdatasetR4.xlsx',2,['AX' num2str(start+1) ':AX' num2str(ende)]);
nom_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AQ2:AR2568');
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[zeros((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
Hw_v=xlsread('JSTdatasetR6.xlsx',1,'BH2:BH2568')/1000;  Hw_v=[zeros((size(CPI_v,1)-size(Hw_v,1)),1); Hw_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);

for co=1:size(start)
    ISO=ISO_v(start(co));
    CPI=CPI_v(start(co):ende(co));
    real_assets=real_assets_v(start(co)+1:ende(co),:);
    nom_assets=nom_assets_v(start(co)+1:ende(co),:);
    rent_p=rent_p_v(start(co):ende(co),:);
    Hw=Hw_v(start(co)+1);

t=1:size(nom_assets,1);
%Data manipulation
%calculate inflation
CPI=CPI./CPI(1);
infl=CPI(2:end)./CPI(1:end-1)-1;

%Calculate inflation and create rents on housing price index
inflH=rent_p(2:end,1)./rent_p(1:end-1,2)-1;

inflxH=(infl-Hw*inflH)/(1-Hw);

for i=1:size(inflH)-5
    
    real_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    nom_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    inflxH5(i,:)=sum(inflxH(i:i+4,:))/5;
    infl5(i,:)=sum(infl(i:i+4,:))/5;
    inflH5(i,:)=sum(inflH(i:i+4,:))/5;
    
end

for i=1:size(inflH)-10
    
    real_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    nom_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    inflxH10(i,:)=sum(inflxH(i:i+9,:))/10;
    infl10(i,:)=sum(infl(i:i+9,:))/10;
    inflH10(i,:)=sum(inflH(i:i+9,:))/10;
    roll_corr10(i,2)=corr(real_assets(i:i+9,2),inflxH(i:i+9,:));
    roll_corr10(i,1)=corr(real_assets(i:i+9,1),inflxH(i:i+9,:));
    
end
    if plots==1

         time=2016-size(infl,1):1:2015;
         figure
         plot(time,infl,'DisplayName','CP');
         hold on;plot(time,real_assets(:,2),'DisplayName','HP');
         hold on; plot(time,real_assets(:,1),'DisplayName','EP');
         hold off;
         legend
         title(ISO)
    end

Data=[real_assets infl inflxH];
Data5=[real_assets5 infl5 inflxH5];
Data10=[real_assets10 infl10 inflxH10];

Data(any(isnan(Data),2),:) = [];
Data5(any(isnan(Data5),2),:) = [];
Data10(any(isnan(Data10),2),:) = [];



[be,~,re,~,ste]=regress(Data(:,1), [ones(size(Data(:,1))) Data(:,3)]); 
[bexh,~,rexh,~,stexh]=regress(Data(:,1), [ones(size(Data(:,1))) Data(:,4)]); 
[bh,~,rh,~,sth]=regress(Data(:,2), [ones(size(Data(:,1))) Data(:,3)]);
[bhxh,~,rhxh,~,sthxh]=regress(Data(:,2), [ones(size(Data(:,1))) Data(:,4)]);

[be5,~,re5,~,ste5]=regress(Data5(:,1), [ones(size(Data5(:,1))) Data5(:,3)]); 
[be5xh,~,re5xh,~,ste5xh]=regress(Data5(:,1), [ones(size(Data5(:,1))) Data5(:,4)]);
[bh5,~,rh5,~,sth5]=regress(Data5(:,2), [ones(size(Data5(:,1))) Data5(:,3)]);
[bh5xh,~,rh5xh,~,sth5xh]=regress(Data5(:,2), [ones(size(Data5(:,1))) Data5(:,4)]);

[be10,~,re10,~,ste10]=regress(Data10(:,1), [ones(size(Data10(:,1))) Data10(:,3)]); 
[be10xh,~,re10xh,~,ste10xh]=regress(Data10(:,1), [ones(size(Data10(:,1))) Data10(:,4)]); 
[bh10,~,rh10,~,sth10]=regress(Data10(:,2), [ones(size(Data10(:,1))) Data10(:,3)]);
[bh10xh,~,rh10xh,~,sth10xh]=regress(Data10(:,2), [ones(size(Data10(:,1))) Data10(:,4)]);

    bet_cov_eh=HACpan_siv(1, [ones(size(Data(:,1))) Data(:,3)],[re rh]);
    bet_cov_ehxh=HACpan_siv(1, [ones(size(Data(:,1))) Data(:,4)],[rexh rhxh]);

    bet_cov_eh5=HACpan_siv(1, [ones(size(Data5(:,1))) Data5(:,3)],[re5 rh5]);
    bet_cov_eh5xh=HACpan_siv(1, [ones(size(Data5(:,1))) Data5(:,4)],[re5xh rh5xh]);

    bet_cov_eh10=HACpan_siv(1, [ones(size(Data10(:,1))) Data10(:,3)],[re10 rh10]);
    bet_cov_eh10xh=HACpan_siv(1, [ones(size(Data10(:,1))) Data10(:,4)],[re10xh rh10xh]);

tstat=([be(2); bh(2); bexh(2); bhxh(2)]-1)./...
      sqrt([bet_cov_eh(2,2);bet_cov_eh(4,4);bet_cov_ehxh(2,2);bet_cov_ehxh(4,4)]);
  
tstat5=([be5(2); bh5(2); be5xh(2); bh5xh(2)]-1)./...
      sqrt([bet_cov_eh5(2,2);bet_cov_eh5(4,4);bet_cov_eh5xh(2,2);bet_cov_eh5xh(4,4)]);
  
tstat10=([be10(2); bh10(2); be10xh(2) ; bh10xh(2)]-1)./...
      sqrt([bet_cov_eh10(2,2); bet_cov_eh10(4,4);bet_cov_eh10xh(2,2);bet_cov_eh10xh(4,4)]);
  
diffstat=([be(2) - bh(2); bexh(2) - bhxh(2)])./...
      sqrt([bet_cov_eh(2,2) + bet_cov_eh(4,4) - 2*bet_cov_eh(2,4);bet_cov_ehxh(2,2) + bet_cov_ehxh(4,4)-2*bet_cov_ehxh(2,4)]);
  
diffstat5=([be5(2) - bh5(2); be5xh(2) - bh5xh(2)])./...
      sqrt([bet_cov_eh5(2,2) + bet_cov_eh5(4,4) - 2*bet_cov_eh5(2,4);bet_cov_eh5xh(2,2)+bet_cov_eh5xh(4,4)-2*bet_cov_eh5xh(2,4)]);
  
diffstat10=([be10(2) - bh10(2); be10xh(2) - bh10xh(2)])./...
      sqrt([bet_cov_eh10(2,2)+ bet_cov_eh10(4,4)- 2*bet_cov_eh10(2,4);bet_cov_eh10xh(2,2)+bet_cov_eh10xh(4,4)-2*bet_cov_eh10xh(2,4)]);

p_diff=1-(tcdf(-diffstat,size(Data,1)-1)+1-tcdf(1-diffstat,size(Data,1)-1));
p_diff5=1-(tcdf(-diffstat5,size(Data5,1)-1)+1-tcdf(1-diffstat5,size(Data5,1)-1));
p_diff10=1-(tcdf(-diffstat10,size(Data10,1)-1)+1-tcdf(1-diffstat10,size(Data10,1)-1));
 
ISO_f(co,:)=ISO;
ae(co,:)=[be(1,1) bexh(1,1)]; be_f(co,:)=[be(2) bexh(2)]; se(co,:)=sqrt([bet_cov_eh(2,2) bet_cov_ehxh(2,2)]);
ah(co,:)=[bh(1) bhxh(1)]; bh_f(co,:)=[bh(2) bhxh(2)]; sh(co,:)=sqrt([bet_cov_eh(4,4) bet_cov_ehxh(4,4)]);
r_sqe(co,:)=[ste(1) stexh(1)]; r_sqh(co,:)=[sth(1) sthxh(1)]; T(co,:)=size(Data,1); diff(co,:)=p_diff';
r_sqe(co,:)= 1-(1-r_sqe(co,:)).*(T(co,:)-1)./(T(co,:)-size(be,1)-2);
r_sqh(co,:)= 1-(1-r_sqh(co,:)).*(T(co,:)-1)./(T(co,:)-size(bh,1)-2);


ae5(co,:)=[be5(1,1) be5xh(1,1)]; be_f5(co,:)=[be5(2) be5xh(2)]; se5(co,:)=sqrt([bet_cov_eh5(2,2) bet_cov_eh5xh(2,2)]);
ah5(co,:)=[bh5(1) bh5xh(1)]; bh_f5(co,:)=[bh5(2) bh5xh(2)]; sh5(co,:)=sqrt([bet_cov_eh5(4,4) bet_cov_eh5xh(4,4)]);
r_sqe5(co,:)=[ste5(1) ste5xh(1)]; r_sqh5(co,:)=[sth5(1) sth5xh(1)]; T5(co,:)=size(Data5,1); diff5(co,:)=p_diff5';
r_sqe5(co,:)= 1-(1-r_sqe5(co,:)).*(T5(co,:)-1)./(T5(co,:)-size(be5,1)-2);
r_sqh5(co,:)= 1-(1-r_sqh5(co,:)).*(T5(co,:)-1)./(T5(co,:)-size(bh5,1)-2);
    
ae10(co,:)=[be10(1,1) be10xh(1,1)]; be_f10(co,:)=[be10(2) be10xh(2)]; se10(co,:)=sqrt([bet_cov_eh10(2,2) bet_cov_eh10xh(2,2)]);
ah10(co,:)=[bh10(1) bh10xh(1)]; bh_f10(co,:)=[bh10(2) bh10xh(2)]; sh10(co,:)=sqrt([bet_cov_eh10(4,4) bet_cov_eh10xh(4,4)]);
r_sqe10(co,:)=[ste10(1) ste10xh(1)]; r_sqh10(co,:)=[sth10(1) sth10xh(1)]; T10(co,:)=size(Data10,1); diff10(co,:)=p_diff10';
r_sqe10(co,:)= 1-(1-r_sqe10(co,:)).*(T10(co,:)-1)./(T10(co,:)-size(be10,1)-2);
r_sqh10(co,:)= 1-(1-r_sqh10(co,:)).*(T10(co,:)-1)./(T10(co,:)-size(bh10,1)-2);

corrs(co,:)=corr(roll_corr10,inflxH10);

clear real_assets5 nom_assets5 inflxH5 infl5 inflH5...
        real_assets10 nom_assets10 inflxH10 infl10 inflH10...
         real_assets20 nom_assets20 inflxH20 infl20 inflH20 roll_corr10

end





%Panel
for co=1:size(start)
    ISO=ISO_v(start(co));
    CPI=CPI_v(start(co):ende(co));
    real_assets=real_assets_v(start(co)+1:ende(co),:);
    nom_assets=nom_assets_v(start(co)+1:ende(co),:);
    rent_p=rent_p_v(start(co):ende(co),:);
    Hw=Hw_v(start(co)+1);

t=1:size(nom_assets,1);
%Data manipulation
%calculate inflation
CPI=CPI./CPI(1);
infl=CPI(2:end)./CPI(1:end-1)-1;

%Calculate inflation and create rents on housing price index
inflH=rent_p(2:end,1)./rent_p(1:end-1,2)-1;

inflxH=(infl-Hw*inflH)/(1-Hw);

for i=1:size(inflH)-5
    
    real_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    nom_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    inflxH5(i,:)=sum(inflxH(i:i+4,:))/5;
    infl5(i,:)=sum(infl(i:i+4,:))/5;
    inflH5(i,:)=sum(inflH(i:i+4,:))/5;
    
end

for i=1:size(inflH)-10
    
    real_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    nom_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    inflxH10(i,:)=sum(inflxH(i:i+9,:))/10;
    infl10(i,:)=sum(infl(i:i+9,:))/10;
    inflH10(i,:)=sum(inflH(i:i+9,:))/10;
    roll_corr10(i,2)=corr(real_assets(i:i+9,2),inflxH(i:i+9,:));
    roll_corr10(i,1)=corr(real_assets(i:i+9,1),inflxH(i:i+9,:));
    
end


Data=[real_assets infl inflxH];
Data5=[real_assets5 infl5 inflxH5];
Data10=[real_assets10 infl10 inflxH10];



if co==1
uPanel=[NaN(max(ende-start)-size(Data,1),size(Data,2)); Data];
uPanel5=[NaN(max(ende-start)-5-size(Data5,1),size(Data5,2)); Data5];
uPanel10=[NaN(max(ende-start)-10-size(Data10,1),size(Data10,2)); Data10];
else
uPanel=[uPanel; [NaN(max(ende-start)-size(Data,1),size(Data,2)); Data]];
uPanel5=[uPanel5; [NaN(max(ende-start)-5-size(Data5,1),size(Data5,2)); Data5]];
uPanel10=[uPanel10; [NaN(max(ende-start)-10-size(Data10,1),size(Data10,2)); Data10]];    
end


uPanel(any(isnan(uPanel),2),:) = NaN(size(uPanel(any(isnan(uPanel),2),:),1),size(Data,2));
uPanel5(any(isnan(uPanel5),2),:) =  NaN(size(uPanel5(any(isnan(uPanel5),2),:),1),size(Data5,2));
uPanel10(any(isnan(uPanel10),2),:) =  NaN(size(uPanel10(any(isnan(uPanel10),2),:),1),size(Data10,2));

Data(any(isnan(Data),2),:) = [];
Data5(any(isnan(Data5),2),:) = [];
Data10(any(isnan(Data10),2),:) = [];





if co==1
co_dum=zeros(size(Data,1), size(start,1)); co_dum(:,co)=ones(size(Data,1),1);
co_dum5=zeros(size(Data5,1), size(start,1)); co_dum5(:,co)=ones(size(Data5,1),1);
co_dum10=zeros(size(Data10,1), size(start,1)); co_dum10(:,co)=ones(size(Data10,1),1);
Panel=[Data co_dum];
Panel5=[Data5 co_dum5];
Panel10=[Data10 co_dum10];
else
co_dum=zeros(size(Data,1), size(start,1)); co_dum(:,co)=ones(size(Data,1),1);
co_dum5=zeros(size(Data5,1), size(start,1)); co_dum5(:,co)=ones(size(Data5,1),1);
co_dum10=zeros(size(Data10,1), size(start,1)); co_dum10(:,co)=ones(size(Data10,1),1);
Panel=[Panel; Data co_dum];
Panel5=[Panel5; Data5 co_dum5];
Panel10=[Panel10; Data10 co_dum10];    
end

clear real_assets5 nom_assets5 inflxH5 infl5 inflH5...
        real_assets10 nom_assets10 inflxH10 infl10 inflH1;
end
    %GM
    co=co+1;
    ISO_f(co,:)='GME';
    
    ae(co,:)=mean(ae);
    ah(co,:)=mean(ah);
    be_f(co,:)=mean(be_f);
    bh_f(co,:)=mean(bh_f);
    
    om=cov([be_f bh_f]);
    se(co,1)=sqrt(om(1,1));
    se(co,2)=sqrt(om(2,2));
    sh(co,1)=sqrt(om(3,3));
    sh(co,2)=sqrt(om(4,4));
    diffstat=([be_f(co,1) - bh_f(co,1); be_f(co,2) - bh_f(co,2)])./...
    sqrt([om(1,1) + om(3,3) - 2*om(1,3);om(2,2) + om(4,4) - 2*om(2,4)]);
    diff(co,:)=1-(tcdf(-diffstat,16-1)+1-tcdf(1-diffstat,16-1));
    r_sqe(co,:)=NaN(1,2); r_sqh(co,:)=NaN(1,2); T(co,:)=NaN(1,1);
    
    ae5(co,:)=mean(ae5);
    ah5(co,:)=mean(ah5);
    be_f5(co,:)=mean(be_f5);
    bh_f5(co,:)=mean(bh_f5);
    
    om=cov([be_f5 bh_f5]);
    se5(co,1)=sqrt(om(1,1));
    se5(co,2)=sqrt(om(2,2));
    sh5(co,1)=sqrt(om(3,3));
    sh5(co,2)=sqrt(om(4,4));
    diffstat=([be_f5(co,1) - bh_f5(co,1); be_f5(co,2) - bh_f5(co,2)])./...
    sqrt([om(1,1) + om(3,3) - 2*om(1,3);om(2,2) + om(4,4) - 2*om(2,4)]);
    diff5(co,:)=1-(tcdf(-diffstat,16-1)+1-tcdf(1-diffstat,16-1));
    r_sqe5(co,:)=NaN(1,2); r_sqh5(co,:)=NaN(1,2); T5(co,:)=NaN(1,1);
   
    ae10(co,:)=mean(ae10);
    ah10(co,:)=mean(ah10);
    be_f10(co,:)=mean(be_f10);
    bh_f10(co,:)=mean(bh_f10);
    
    om=cov([be_f10 bh_f10]);
    se10(co,1)=sqrt(om(1,1));
    se10(co,2)=sqrt(om(2,2));
    sh10(co,1)=sqrt(om(3,3));
    sh10(co,2)=sqrt(om(4,4));
    diffstat=([be_f10(co,1) - bh_f10(co,1); be_f10(co,2) - bh_f10(co,2)])./...
    sqrt([om(1,1) + om(3,3) - 2*om(1,3);om(2,2) + om(4,4) - 2*om(2,4)]);
    diff10(co,:)=1-(tcdf(-diffstat,16-1)+1-tcdf(1-diffstat,16-1));
    r_sqe10(co,:)=NaN(1,2); r_sqh10(co,:)=NaN(1,2); T10(co,:)=NaN(1,1);




%     POLS
    [be,test,re,~,ste]=regress(uPanel(:,1), [ones(size(uPanel(:,1))) uPanel(:,3)]); 
    [bexh,~,rexh,~,stexh]=regress(uPanel(:,1), [ones(size(uPanel(:,1))) uPanel(:,4)]); 
    [bh,~,rh,~,sth]=regress(uPanel(:,2), [ones(size(uPanel(:,1))) uPanel(:,3)]);
    [bhxh,~,rhxh,~,sthxh]=regress(uPanel(:,2), [ones(size(uPanel(:,1))) uPanel(:,4)]);

    [be5,~,re5,~,ste5]=regress(uPanel5(:,1), [ones(size(uPanel5(:,1))) uPanel5(:,3)]); 
    [be5xh,~,re5xh,~,ste5xh]=regress(uPanel5(:,1), [ones(size(uPanel5(:,1))) uPanel5(:,4)]);
    [bh5,~,rh5,~,sth5]=regress(uPanel5(:,2), [ones(size(uPanel5(:,1))) uPanel5(:,3)]);
    [bh5xh,~,rh5xh,~,sth5xh]=regress(uPanel5(:,2), [ones(size(uPanel5(:,1))) uPanel5(:,4)]);

    [be10,~,re10,~,ste10]=regress(uPanel10(:,1), [ones(size(uPanel10(:,1))) uPanel10(:,3)]); 
    [be10xh,~,re10xh,~,ste10xh]=regress(uPanel10(:,1), [ones(size(uPanel10(:,1))) uPanel10(:,4)]); 
    [bh10,~,rh10,~,sth10]=regress(uPanel10(:,2), [ones(size(uPanel10(:,1))) uPanel10(:,3)]);
    [bh10xh,~,rh10xh,~,sth10xh]=regress(uPanel10(:,2), [ones(size(uPanel10(:,1))) uPanel10(:,4)]);

    bet_cov_eh=HACpan_siv(16, [ones(size(uPanel(:,1))) uPanel(:,3)],[re rh]);
    bet_cov_ehxh=HACpan_siv(16, [ones(size(uPanel(:,1))) uPanel(:,4)],[rexh rhxh]);

    bet_cov_eh5=HACpan_siv(16, [ones(size(uPanel5(:,1))) uPanel5(:,3)],[re5 rh5]);
    bet_cov_eh5xh=HACpan_siv(16, [ones(size(uPanel5(:,1))) uPanel5(:,4)],[re5xh rh5xh]);

    bet_cov_eh10=HACpan_siv(16, [ones(size(uPanel10(:,1))) uPanel10(:,3)],[re10 rh10]);
    bet_cov_eh10xh=HACpan_siv(16, [ones(size(uPanel10(:,1))) uPanel10(:,4)],[re10xh rh10xh]);
    
    

    tstat=([be(2); bh(2); bexh(2); bhxh(2)]-1)./...
          sqrt([bet_cov_eh(2,2);bet_cov_eh(4,4);bet_cov_ehxh(2,2);bet_cov_ehxh(4,4)]);

    tstat5=([be5(2); bh5(2); be5xh(2); bh5xh(2)]-1)./...
          sqrt([bet_cov_eh5(2,2);bet_cov_eh5(4,4);bet_cov_eh5xh(2,2);bet_cov_eh5xh(4,4)]);

    tstat10=([be10(2); bh10(2); be10xh(2) ; bh10xh(2)]-1)./...
          sqrt([bet_cov_eh10(2,2); bet_cov_eh10(4,4);bet_cov_eh10xh(2,2);bet_cov_eh10xh(4,4)]);

    diffstat=([be(2) - bh(2); bexh(2) - bhxh(2)])./...
          sqrt([bet_cov_eh(2,2) + bet_cov_eh(4,4) - 2*bet_cov_eh(2,4);bet_cov_ehxh(2,2) + bet_cov_ehxh(4,4)-2*bet_cov_ehxh(2,4)]);

    diffstat5=([be5(2) - bh5(2); be5xh(2) - bh5xh(2)])./...
          sqrt([bet_cov_eh5(2,2) + bet_cov_eh5(4,4) - 2*bet_cov_eh5(2,4);bet_cov_eh5xh(2,2)+bet_cov_eh5xh(4,4)-2*bet_cov_eh5xh(2,4)]);

    diffstat10=([be10(2) - bh10(2); be10xh(2) - bh10xh(2)])./...
          sqrt([bet_cov_eh10(2,2)+ bet_cov_eh10(4,4)- 2*bet_cov_eh10(2,4);bet_cov_eh10xh(2,2)+bet_cov_eh10xh(4,4)-2*bet_cov_eh10xh(2,4)]);

    p_diff=1-(tcdf(-diffstat,size(Panel,1)-1)+1-tcdf(1-diffstat,size(Panel,1)-1));
    p_diff5=1-(tcdf(-diffstat5,size(Panel5,1)-1)+1-tcdf(1-diffstat5,size(Panel5,1)-1));
    p_diff10=1-(tcdf(-diffstat10,size(Panel10,1)-1)+1-tcdf(1-diffstat10,size(Panel10,1)-1));
    
    co=co+1;
    
    ISO_f(co,:)='POLS';
    ae(co,:)=[be(1,1) bexh(1,1)]; be_f(co,:)=[be(2) bexh(2)]; se(co,:)=sqrt([bet_cov_eh(2,2) bet_cov_ehxh(2,2)]);
    ah(co,:)=[bh(1) bhxh(1)]; bh_f(co,:)=[bh(2) bhxh(2)]; sh(co,:)=sqrt([bet_cov_eh(4,4) bet_cov_ehxh(4,4)]);
    r_sqe(co,:)=[ste(1) stexh(1)]; r_sqh(co,:)=[sth(1) sthxh(1)]; T(co,:)=size(Panel,1); diff(co,:)=p_diff';
    r_sqe(co,:)= 1-(1-r_sqe(co,:)).*(T(co,:)-1)./(T(co,:)-size(be,1)-2);
    r_sqh(co,:)= 1-(1-r_sqh(co,:)).*(T(co,:)-1)./(T(co,:)-size(bh,1)-2);
    
    
    ae5(co,:)=[be5(1,1) be5xh(1,1)]; be_f5(co,:)=[be5(2) be5xh(2)]; se5(co,:)=sqrt([bet_cov_eh5(2,2) bet_cov_eh5xh(2,2)]);
    ah5(co,:)=[bh5(1) bh5xh(1)]; bh_f5(co,:)=[bh5(2) bh5xh(2)]; sh5(co,:)=sqrt([bet_cov_eh5(4,4) bet_cov_eh5xh(4,4)]);
    r_sqe5(co,:)=[ste5(1) ste5xh(1)]; r_sqh5(co,:)=[sth5(1) sth5xh(1)]; T5(co,:)=size(Panel5,1); diff5(co,:)=p_diff5';
    r_sqe5(co,:)= 1-(1-r_sqe5(co,:)).*(T5(co,:)-1)./(T5(co,:)-size(be5,1)-2);
    r_sqh5(co,:)= 1-(1-r_sqh5(co,:)).*(T5(co,:)-1)./(T5(co,:)-size(bh5,1)-2);

    ae10(co,:)=[be10(1,1) be10xh(1,1)]; be_f10(co,:)=[be10(2) be10xh(2)]; se10(co,:)=sqrt([bet_cov_eh10(2,2) bet_cov_eh10xh(2,2)]);
    ah10(co,:)=[bh10(1) bh10xh(1)]; bh_f10(co,:)=[bh10(2) bh10xh(2)]; sh10(co,:)=sqrt([bet_cov_eh10(4,4) bet_cov_eh10xh(4,4)]);
    r_sqe10(co,:)=[ste10(1) ste10xh(1)]; r_sqh10(co,:)=[sth10(1) sth10xh(1)]; T10(co,:)=size(Panel10,1); diff10(co,:)=p_diff10';
    r_sqe10(co,:)= 1-(1-r_sqe10(co,:)).*(T10(co,:)-1)./(T10(co,:)-size(be10,1)-2);
    r_sqh10(co,:)= 1-(1-r_sqh10(co,:)).*(T10(co,:)-1)./(T10(co,:)-size(bh10,1)-2);
    

    
    
    ISO_f=cellstr(ISO_f);
    one=table(ISO_f,ae,be_f,se,ah,bh_f,sh,diff,r_sqe,r_sqh,T);
    oneh=table(ISO_f,bh_f(:,1),sh(:,1),r_sqh(:,1),be_f(:,1),se(:,1),r_sqe(:,1),diff(:,1),T);
    onexh=table(ISO_f,bh_f(:,2),sh(:,2),r_sqh(:,2),be_f(:,2),se(:,2),r_sqe(:,2),diff(:,2),T);

    five=table(ISO_f,ae5,be_f5,se5,ah5,bh_f5,sh5,diff5,r_sqe5,r_sqh5,T5);
    fiveh=table(ISO_f,bh_f5(:,1),sh5(:,1),r_sqh5(:,1),be_f5(:,1),se5(:,1),r_sqe5(:,1),diff5(:,1),T5);
    fivexh=table(ISO_f,bh_f5(:,2),sh5(:,2),r_sqh5(:,2),be_f5(:,2),se5(:,2),r_sqe5(:,2),diff5(:,2),T5);

    ten=table(ISO_f,ae10,be_f10,se10,ah10,bh_f10,sh10,diff10,r_sqe10,r_sqh10,T10);
    tenh=table(ISO_f,bh_f10(:,1),sh10(:,1),r_sqh10(:,1),be_f10(:,1),se10(:,1),r_sqe10(:,1),diff10(:,1),T10);
    tenxh=table(ISO_f,bh_f10(:,2),sh10(:,2),r_sqh10(:,2),be_f10(:,2),se10(:,2),r_sqe10(:,2),diff10(:,2),T10);



table2latex((oneh),'.\Tables\oneh.tex')
table2latex((onexh),'.\Tables\onexh.tex')

table2latex((fiveh),'.\Tables\fiveh.tex')
table2latex((fivexh),'.\Tables\fivexh.tex')

table2latex((tenh),'.\Tables\tenh.tex')
table2latex((tenxh),'.\Tables\tenxh.tex')
