%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=0; ex_ger=1;

%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
HP_v=xlsread('JSTdatasetR6.xlsx',1,'AP2:AP2568'); HP_v=[NaN((size(CPI_v,1)-size(HP_v,1)),1); HP_v];
EP_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AO2568'); EP_v=[NaN((size(CPI_v,1)-size(EP_v,1)),1); EP_v];
HPP_v=xlsread('JSTdatasetR6.xlsx',1,'AU2:AU2568'); HPP_v=[NaN((size(CPI_v,1)-size(HPP_v,1)),1); HPP_v];
EPP_v=xlsread('JSTdatasetR6.xlsx',1,'AX2:AX2568'); EPP_v=[NaN((size(CPI_v,1)-size(EPP_v,1)),1); EPP_v];
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[NaN((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
div_p_v=[xlsread('JSTdatasetR6.xlsx',1,'BD2:BD2568'), xlsread('JSTdatasetR6.xlsx',1,'AY2:AY2568')]; div_p_v=[NaN((size(CPI_v,1)-size(div_p_v,1)),2); div_p_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);



for co=1:17
    ISO=ISO_v(1+size(CPI_v,1)/17*(co-1));
    CPI=[CPI_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co))];
    HP=log(1+[HP_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co)); 0]);
    EP=log(1+[EP_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co)); 0]);
    HPP=log(1+[HPP_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co)); 0]);
    EPP=log(1+[EPP_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co)); 0]);
    rent_p=rent_p_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co),:);
    div_p=div_p_v(1+size(CPI_v,1)/17*(co-1):size(CPI_v,1)/17*(co),:);
    
    %Calculate inflation and create rents on housing price index
    HPY=rent_p(2:end,1)./rent_p(1:end-1,2)-1;
    EPY=div_p(2:end,1)./div_p(1:end-1,2)-1;
    
    HPY=log(1+[NaN; HPY; 0]);
    EPY=log(1+[NaN; EPY; 0]);
    nans=sum(isnan([HP EP HPP EPP HPY EPY]));
    %HP((isnan(HP)))=mean(HP,'omitnan');
    %EP((isnan(EP)))=mean(EP,'omitnan');
    
    
    
    time=1:size(CPI,1);
    
    for i=size(time,2):-1:2
        HP(i-1)=HP(i)-HP(i-1);
        EP(i-1)=EP(i)-EP(i-1);
        HPP(i-1)=HPP(i)-HPP(i-1);
        EPP(i-1)=EPP(i)-EPP(i-1);
        HPY(i-1)=HPY(i)-HPY(i-1);   
        EPY(i-1)=EPY(i)-EPY(i-1);
    end
    
    if co==5
        EP(1:end-71)=NaN;
    end
    
    CPI(isnan(HP(1:end)) & isnan(EP(1:end)))= NaN;
    
    CP=log(CPI)-log(CPI(end));
    HP=HP(2:end)-HP(end);
    EP=EP(2:end)-EP(end);
    HPP=HPP(2:end)-HPP(end);
    EPP=EPP(2:end)-EPP(end);
    HPY=HPY(2:end)-HPY(end);
    EPY=EPY(2:end)-EPY(end);
    %CP=CPI./CPI(1);
    %HP=log(HP);
    %EP=log(EP);
    %CP=log(CP);
    
    nans=sum(isnan([HP EP HPP EPP]))./size(CP,1);
    
    ISO_help=cell(max(ende-start),1);
    ISO_help(:)={ISO};
     
    year_vec_full=((2021-size(CP)):1:2020)';
    Data=[HP EP CP HP-CP EP-CP HPP EPP HPP-CP EPP-CP HPY EPY HPY-CP EPY-CP];
if co==1
Panel=[co*ones(151,1) (1870:1:2020)' Data];
Panel50=[co*ones(71,1) (1950:1:2020)' Data(end-70:end,:)];
else
Panel=[Panel;[co*ones(151,1) (1870:1:2020)' [Data]]]; 
Panel50=[Panel50;co*ones(71,1) (1950:1:2020)' Data(end-70:end,:)];
end


end
 
%tab=table(ISO, Data);
