%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=0; ex_ger=0;

%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
HP_v=xlsread('JSTdatasetR6.xlsx',1,'AP2:AP2568'); HP_v=[NaN((size(CPI_v,1)-size(HP_v,1)),1); HP_v];
EP_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AO2568'); EP_v=[NaN((size(CPI_v,1)-size(EP_v,1)),1); EP_v];
HPP_v=xlsread('JSTdatasetR6.xlsx',1,'AU2:AU2568'); HPP_v=[NaN((size(CPI_v,1)-size(HPP_v,1)),1); HPP_v];
EPP_v=xlsread('JSTdatasetR6.xlsx',1,'AX2:AX2568'); EPP_v=[NaN((size(CPI_v,1)-size(EPP_v,1)),1); EPP_v];
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[NaN((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
div_p_v=[xlsread('JSTdatasetR6.xlsx',1,'BD2:BD2568'), xlsread('JSTdatasetR6.xlsx',1,'AY2:AY2568')]; div_p_v=[NaN((size(CPI_v,1)-size(div_p_v,1)),2); div_p_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);


co_g=[1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 17];
para_hct_uni.ll.B=zeros(2,16,16);
para_ect_uni.ll.B=zeros(2,16,16);
para_hct.ll.B=zeros(2,16,16);
para_ect.ll.B=zeros(2,16,16);
para_hc.ll.B=zeros(2,16,16);
para_ec.ll.B=zeros(2,16,16);
for co=1:16
    stemp=co_g(co);
    ISO=ISO_v(1+size(CPI_v,1)/17*(stemp-1));
    CPI=[CPI_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp))];
    HP=log(1+[HP_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp)); 0]);
    EP=log(1+[EP_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp)); 0]);
    HPP=log(1+[HPP_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp)); 0]);
    EPP=log(1+[EPP_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp)); 0]);
    rent_p=rent_p_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp),:);
    div_p=div_p_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp),:);
    
    %Calculate inflation and create rents on housing price index
    HPY=rent_p(2:end,1)./rent_p(1:end-1,2)-1;
    EPY=div_p(2:end,1)./div_p(1:end-1,2)-1;
    
    HPY=log(1+[NaN; HPY; 0]);
    EPY=log(1+[NaN; EPY; 0]);
    
    
    nans=sum(isnan([HP EP HPP EPP HPY EPY]));
    ISO_f(co)=ISO;
    
    
    time=1:size(CPI,1);
    
    for i=size(time,2):-1:2
        HP(i-1)=HP(i)-HP(i-1);
        EP(i-1)=EP(i)-EP(i-1);
        HPP(i-1)=HPP(i)-HPP(i-1);
        EPP(i-1)=EPP(i)-EPP(i-1);
        HPY(i-1)=HPY(i)-HPY(i-1);   
        EPY(i-1)=EPY(i)-EPY(i-1);
    end
    
    
    CP=log(CPI)-log(CPI(end));
    HP=HP(2:end)-HP(end);
    EP=EP(2:end)-EP(end);
    HPP=HPP(2:end)-HPP(end);
    EPP=EPP(2:end)-EPP(end);
    HPY=HPY(2:end)-HPY(end);
    EPY=EPY(2:end)-EPY(end);
    %CP=CPI./CPI(1);
    %HP=log(HP);
    %EP=log(EP);
    %CP=log(CP);
    
    nans=sum(isnan([HP EP HPP EPP]))./size(CP,1);
    
    ISO_help=cell(max(ende-start),1);
    ISO_help(:)={ISO};
     
    year_vec_full=((2021-size(CP)):1:2020)';
    Data=[HP EP CP HP-CP EP-CP HPP EPP HPP-CP EPP-CP HPY EPY HPY-CP EPY-CP];
if co==1
Panel=[co*ones(151,1) (1870:1:2020)' Data];
Panel50=[co*ones(71,1) (1950:1:2020)' Data(end-70:end,:)];
else
Panel=[Panel;[co*ones(151,1) (1870:1:2020)' [Data]]]; 
Panel50=[Panel50;co*ones(71,1) (1950:1:2020)' Data(end-70:end,:)];
end

HP=HPP(end-70:end,:);
EP=EPP(end-70:end,:);
CP=CP(end-70:end,:);


try
    BIC=0;
    zh=HP-CP;
    for lag=8:-1:0 
         [~,~,~,~,uni_reg_df_hp] = adftest(zh,'model','TS','lags',lag);
        BIC(lag+1)=uni_reg_df_hp(1).BIC;
    end
    [~,lag]=min(BIC'); lag=lag-1;
    [~,uni_hct(co,:),uni_t_hc(co,:),~,uni_reg_df_hp] = adftest(zh,'model','TS','lags',lag,'test',{'t1','t2'});
    lag_uni_hct(co)=lag;
    bethcut(co,:)=uni_reg_df_hp(1).coeff(2:3);
    sebhcut(co)=0;
    para_hct_uni.c0(co)=uni_reg_df_hp(1).coeff(1);
    para_hct_uni.beta(:,co)=[1;-1];
    para_hct_uni.delta(:,co)=uni_reg_df_hp(1).coeff(2);
    [alpha,B,c1,Cov]=vecm2([HP CP],[1;-1],uni_reg_df_hp(1).coeff(1),uni_reg_df_hp(1).coeff(2),1);
    para_hct_uni.l1.alpha(:,co)=alpha;  para_hct_uni.l1.B(:,:,co)=B;  para_hct_uni.l1.c1(:,co)=c1;  para_hct_uni.l1.cov(:,:,co)=Cov;
    [alpha,B,c1,Cov]=vecm2([HP CP],[1;-1],uni_reg_df_hp(1).coeff(1),uni_reg_df_hp(1).coeff(2),2);
    para_hct_uni.l2.alpha(:,co)=alpha;  para_hct_uni.l2.B(:,:,co)=B;  para_hct_uni.l2.c1(:,co)=c1;  para_hct_uni.l2.cov(:,:,co)=Cov;    
    [alpha,B,c1,Cov]=vecm2([HP CP],[1;-1],uni_reg_df_hp(1).coeff(1),uni_reg_df_hp(1).coeff(2),lag);
    para_hct_uni.ll.alpha(:,co)=alpha; para_hct_uni.ll.B(:,1:lag*2,co)=B;   para_hct_uni.ll.c1(:,co)=c1; para_hct_uni.ll.cov(:,:,co)=Cov;    
    
catch
    uni_hct(co,:)=NaN(1,2);
    bethcut(co,:)=NaN(1,2);
    sebhcut(co)=NaN(1,1);
    lag_uni_hct(co)=NaN(1,1);
    para_hct_uni.l1.alpha(:,co)=NaN(2,1);  para_hct_uni.l1.B(:,:,co)=NaN(2,2,1);  para_hct_uni.l1.c1(:,co)=NaN(2,1);  para_hct_uni.l1.cov(:,:,co)=NaN(2,2,1);
    para_hct_uni.c0(co)=NaN(1,1);  para_hct_uni.beta(:,co)=NaN(2,1);    para_hct_uni.delta(:,co)=NaN(1,1);
    para_hct_uni.l2.alpha(:,co)=NaN(2,1);  para_hct_uni.l2.B(:,:,co)=NaN(2,4,1);  
    para_hct_uni.ll.alpha(:,co)=NaN(2,1);  para_hct_uni.ll.B(:,:,co)=NaN(2,16,1); para_hct_uni.ll.c1(:,co)=NaN(2,1);  para_hct_uni.ll.cov(:,:,co)=NaN(2,2,1);
end

try
    ze=EP-CP;
    BIC=0;
    for lag=8:-1:0 
         [~,~,~,~,uni_reg_df_ep] = adftest(ze,'model','TS','lags',lag);
        BIC(lag+1)=uni_reg_df_ep(1).BIC;
    end
    [~,lag]=min(BIC'); lag=lag-1;
    [~,uni_ect(co,:),uni_t_ec(co,:),~,uni_reg_df_ept] = adftest(ze,'model','TS','lags',lag,'test',{'t1','t2'});
    lag_uni_ect(co)=lag;
    betecut(co,:)=uni_reg_df_ept(1).coeff(2:3);
    sebecut(co)=0;
    para_ect_uni.c0(co)=uni_reg_df_ept(1).coeff(1);
    para_ect_uni.beta(:,co)=[1;-1];
    para_ect_uni.delta(:,co)=uni_reg_df_ept(1).coeff(2);
    [alpha,B,c1,Cov]=vecm2([EP CP],[1;-1],uni_reg_df_ept(1).coeff(1),uni_reg_df_ept(1).coeff(2),1);
    para_ect_uni.l1.alpha(:,co)=alpha;  para_ect_uni.l1.B(:,:,co)=B;  para_ect_uni.l1.c1(:,co)=c1;  para_ect_uni.l1.cov(:,:,co)=Cov;
    [alpha,B,c1,Cov]=vecm2([EP CP],[1;-1],uni_reg_df_ept(1).coeff(1),uni_reg_df_ept(1).coeff(2),2);
    para_ect_uni.l2.alpha(:,co)=alpha;  para_ect_uni.l2.B(:,:,co)=B;  para_ect_uni.l2.c1(:,co)=c1;  para_ect_uni.l2.cov(:,:,co)=Cov;   
    [alpha,B,c1,Cov]=vecm2([EP CP],[1;-1],uni_reg_df_ept(1).coeff(1),uni_reg_df_ept(1).coeff(2),lag);
    para_ect_uni.ll.alpha(:,co)=alpha; para_ect_uni.ll.B(:,1:lag*2,co)=B;   para_ect_uni.ll.c1(:,co)=c1; para_ect_uni.ll.cov(:,:,co)=Cov;    
   
catch
     uni_ect(co,:)=NaN(1,2);
     betecut(co,:)=NaN(1,2);
     sebecut(co)=NaN(1,1);
     lag_uni_ect(co)=NaN(1,1);
     para_ect_uni.l1.alpha(:,co)=NaN(2,1);  para_ect_uni.l1.B(:,:,co)=NaN(2,2,1);  para_ect_uni.l1.c1(:,co)=NaN(2,1);  para_ect_uni.l1.cov(:,:,co)=NaN(2,2,1);
     para_ect_uni.c0(co)=NaN(1,1);  para_ect_uni.beta(:,co)=NaN(2,1);    para_ect_uni.delta(:,co)=NaN(1,1);
     para_ect_uni.l2.alpha(:,co)=NaN(2,1);  para_ect_uni.l2.B(:,:,co)=NaN(2,4,1);  para_ect_uni.l2.c1(:,co)=NaN(2,1);  para_ect_uni.l2.cov(:,:,co)=NaN(2,2,1);
     para_ect_uni.ll.alpha(:,co)=NaN(2,1);  para_ect_uni.ll.B(:,:,co)=NaN(2,16,1);  para_ect_uni.ll.c1(:,co)=NaN(2,1);  para_ect_uni.ll.cov(:,:,co)=NaN(2,2,1);
end
    
    try
    BIC=0;
    for lag=8:-1:0 
        [~,~,~,~,~,reg2h] = egcitest([HP CP],'lag',lag,'test',{'t1','t2'});
         BIC(lag+1)=reg2h(2).BIC;
    end
    [~,lag]=min(BIC'); lag=lag-1;
    [~, hcp(co,:),t_hc(co,:),~,reg1h,reg2h] = egcitest([HP CP],'lag',lag,'test',{'t1','t2'});
        bethc(co,1)=reg1h(1).coeff(2);
        bethc(co,2)=reg2h(1).coeff(1);
        sebhc(co)=reg1h(1).se(2);
        lag_hc(co)=lag;
         para_hc.c0(co)=reg1h(1).coeff(1);
         para_hc.beta(:,co)=[1;-reg1h(1).coeff(2)];
         para_hc.delta(:,co)=0;
        [alpha,B,c1,Cov]=vecm2([HP CP],[1;-reg1h(1).coeff(2)],reg1h(1).coeff(1),0,1);
         para_hc.l1.alpha(:,co)=alpha;  para_hc.l1.B(:,:,co)=B;  para_hc.l1.c1(:,co)=c1;  para_hc.l1.cov(:,:,co)=Cov;
        [alpha,B,c1,Cov]=vecm2([HP CP],[1;-reg1h(1).coeff(2)],reg1h(1).coeff(1),0,2);
         para_hc.l2.alpha(:,co)=alpha;  para_hc.l2.B(:,:,co)=B;  para_hc.l2.c1(:,co)=c1;  para_hc.l2.cov(:,:,co)=Cov;   
         [alpha,B,c1,Cov]=vecm2([HP CP],[1;-reg1h(1).coeff(2)],reg1h(1).coeff(1),0,lag);
         para_hc.ll.alpha(:,co)=alpha;  para_hc.ll.B(:,1:lag*2,co)=B;  para_hc.ll.c1(:,co)=c1;  para_hc.ll.cov(:,:,co)=Cov;
    catch
          hcp(co,:)=NaN(1,2);
     bethc(co,:)=NaN(1,2);
     sebhc(co)=NaN(1,1);
     lag_hc(co)=NaN(1,1);
     para_hc.l1.alpha(:,co)=NaN(2,1);  para_hc.l1.B(:,:,co)=NaN(2,2,1);  para_hc.l1.c1(:,co)=NaN(2,1);  para_hc.l1.cov(:,:,co)=NaN(2,2,1);
     para_hc.c0(co)=NaN(1,1);  para_hc.beta(:,co)=NaN(2,1);    para_hc.delta(:,co)=NaN(1,1);
     para_hc.l2.alpha(:,co)=NaN(2,1);  para_hc.l2.B(:,:,co)=NaN(2,4,1);  para_hc.l2.c1(:,co)=NaN(2,1);  para_hc.l2.cov(:,:,co)=NaN(2,2,1);
     para_hc.ll.alpha(:,co)=NaN(2,1);  para_hc.ll.B(:,:,co)=NaN(2,16,1);  para_hc.ll.c1(:,co)=NaN(2,1);  para_hc.ll.cov(:,:,co)=NaN(2,2,1);
    end
  
        try
            
    BIC=0;
    for lag=8:-1:0 
        
        [~,~,~,~,~,reg2e] = egcitest([EP CP],'lag',lag,'test',{'t1','t2'});
        BIC(lag+1)=reg2e(1).BIC;
    end
    [~,lag]=min(BIC'); lag=lag-1;
    [~,ecp(co,:),t_ec(co,:),~,reg1e,reg2e] = egcitest([EP CP],'lag',lag,'test',{'t1','t2'});
        betec(co,1)=reg1e(1).coeff(2);
        betec(co,2)=reg2e(1).coeff(1);
        sebec(co)=reg1e(1).se(2);
        lag_ec(co)=lag;
      para_ec.c0(co)=reg1e(1).coeff(1);
         para_ec.beta(:,co)=[1;-reg1e(1).coeff(2)];
         para_ec.delta(:,co)=0;
        [alpha,B,c1,Cov]=vecm2([EP CP],[1;-reg1e(1).coeff(2)],reg1e(1).coeff(1),0,1);
         para_ec.l1.alpha(:,co)=alpha;  para_ec.l1.B(:,:,co)=B;  para_ec.l1.c1(:,co)=c1;  para_ec.l1.cov(:,:,co)=Cov;
        [alpha,B,c1,Cov]=vecm2([EP CP],[1;-reg1e(1).coeff(2)],reg1e(1).coeff(1),0,2);
         para_ec.l2.alpha(:,co)=alpha;  para_ec.l2.B(:,:,co)=B;  para_ec.l2.c1(:,co)=c1;  para_ec.l2.cov(:,:,co)=Cov; 
          [alpha,B,c1,Cov]=vecm2([EP CP],[1;-reg1e(1).coeff(2)],reg1e(1).coeff(1),0,lag);
         para_ec.ll.alpha(:,co)=alpha;  para_ec.ll.B(:,1:lag*2,co)=B;  para_ec.ll.c1(:,co)=c1;  para_ec.ll.cov(:,:,co)=Cov; 
    
        catch
       
     betec(co,:)=NaN(1,2);
     sebec(co)=NaN(1,1);
     lag_uni_ec(co)=NaN(1,1);
     para_ec.l1.alpha(:,co)=NaN(2,1);  para_ec.l1.B(:,:,co)=NaN(2,2,1);  para_ec.l1.c1(:,co)=NaN(2,1);  para_ec.l1.cov(:,:,co)=NaN(2,2,1);
     para_ec.c0(co)=NaN(1,1);  para_ec.beta(:,co)=NaN(2,1);    para_ec.delta(:,co)=NaN(1,1);
     para_ec.l2.alpha(:,co)=NaN(2,1);  para_ec.l2.B(:,:,co)=NaN(2,4,1);  para_ec.l2.c1(:,co)=NaN(2,1);  para_ec.l2.cov(:,:,co)=NaN(2,2,1);
     para_ec.ll.alpha(:,co)=NaN(2,1);  para_ec.ll.B(:,:,co)=NaN(2,16,1);  para_ec.ll.c1(:,co)=NaN(2,1);  para_ec.ll.cov(:,:,co)=NaN(2,2,1);
        end
    
    
    
    try
    BIC=0;
    for lag=8:-1:0 
        [~,~,~,~,~,reg2ht] = egcitest([HP CP],'lag',lag,'test',{'t1','t2'},'creg','ct');
         BIC(lag+1)=reg2ht(2).BIC;
    end
    [~,lag]=min(BIC'); lag=lag-1;
    [~, hcpt(co,:),t_hct(co,:),~,reg1ht,reg2ht] = egcitest([HP CP],'lag',lag,'test',{'t1','t2'},'creg','ct');
        bethct(co,1:2)=reg1ht(1).coeff(2:3);
        bethct(co,3)=reg2ht(1).coeff(1);
        sebhct(co)=reg1ht(1).se(3);
        lag_hct(co)=lag;
         para_hct.c0(co)=reg1ht(1).coeff(1);
         para_hct.beta(:,co)=[1;-reg1ht(1).coeff(3)];
         para_hct.delta(:,co)=0;
        [alpha,B,c1,Cov]=vecm2([HP CP],[1;-reg1ht(1).coeff(3)],reg1ht(1).coeff(1),0,1);
         para_hct.l1.alpha(:,co)=alpha;  para_hct.l1.B(:,:,co)=B;  para_hct.l1.c1(:,co)=c1;  para_hct.l1.cov(:,:,co)=Cov;
        [alpha,B,c1,Cov]=vecm2([HP CP],[1;-reg1ht(1).coeff(3)],reg1ht(1).coeff(1),reg1ht(1).coeff(2),2);
         para_hct.l2.alpha(:,co)=alpha;  para_hct.l2.B(:,:,co)=B;  para_hct.l2.c1(:,co)=c1;  para_hct.l2.cov(:,:,co)=Cov;  
        [alpha,B,c1,Cov]=vecm2([HP CP],[1;-reg1ht(1).coeff(3)],reg1ht(1).coeff(1),reg1ht(1).coeff(2),lag);
         para_hct.ll.alpha(:,co)=alpha;  para_hct.ll.B(:,1:lag*2,co)=B;  para_hct.ll.c1(:,co)=c1;  para_hct.ll.cov(:,:,co)=Cov;    

    catch
      
     bethct(co,:)=NaN(1,3);
     sebhct(co)=NaN(1,1);
     lag_uni_ec(co)=NaN(1,1);
     irf_hc(:,co,1)=NaN(40,1);
     irf_hc(:,co,2)=NaN(40,1);
     para_hct.l1.alpha(:,co)=NaN(2,1);  para_hct.l1.B(:,:,co)=NaN(2,2,1);  para_hct.l1.c1(:,co)=NaN(2,1);  para_hct.l1.cov(:,:,co)=NaN(2,2,1);
     para_hct.c0(co)=NaN(1,1);  para_hct.beta(:,co)=NaN(2,1);    para_hct.delta(:,co)=NaN(1,1);
     para_hct.ll.alpha(:,co)=NaN(2,1);  para_hct.ll.B(:,:,co)=NaN(2,16,1);  para_hct.ll.c1(:,co)=NaN(2,1);  para_hct.ll.cov(:,:,co)=NaN(2,2,1);
    end
        
    try
      BIC=0;
        for lag=8:-1:0         
            [~,~,~,~,~,reg2et] = egcitest([EP CP],'lag',lag,'test',{'t1','t2'},'creg','ct');
            BIC(lag+1)=reg2et(1).BIC;
        end
        [~,lag]=min(BIC'); lag=lag-1;
        [~,ecpt(co,:),t_ect(co,:),~,reg1et,reg2et] = egcitest([EP CP],'lag',lag,'test',{'t1','t2'},'creg','ct');
            betect(co,1:2)=reg1et(1).coeff(2:3);
            betect(co,3)=reg2et(1).coeff(1);
            sebect(co)=reg1et(1).se(3);
            lag_ect(co)=lag;
          para_ect.c0(co)=reg1e(1).coeff(1);
             para_ect.beta(:,co)=[1;-reg1et(1).coeff(3)];
             para_ect.delta(:,co)=0;
            [alpha,B,c1,Cov]=vecm2([EP CP],[1;-reg1et(1).coeff(3)],reg1et(1).coeff(1),reg1et(1).coeff(2),1);
             para_ect.l1.alpha(:,co)=alpha;  para_ect.l1.B(:,:,co)=B;  para_ect.l1.c1(:,co)=c1;  para_ect.l1.cov(:,:,co)=Cov;
            [alpha,B,c1,Cov]=vecm2([EP CP],[1;-reg1et(1).coeff(3)],reg1et(1).coeff(1),reg1et(1).coeff(2),2);
             para_ect.l2.alpha(:,co)=alpha;  para_ect.l2.B(:,:,co)=B;  para_ect.l2.c1(:,co)=c1;  para_ect.l2.cov(:,:,co)=Cov;   
             [alpha,B,c1,Cov]=vecm2([EP CP],[1;-reg1et(1).coeff(3)],reg1et(1).coeff(1),reg1et(1).coeff(2),lag);
             para_ect.ll.alpha(:,co)=alpha;  para_ect.ll.B(:,1:lag*2,co)=B;  para_ect.ll.c1(:,co)=c1;  para_ect.ll.cov(:,:,co)=Cov;
             
    catch
           betect(co,:)=NaN(1,3);
     sebect(co)=NaN(1,1);
     lag_uni_ect(co)=NaN(1,1);
     irf_ect(:,co,1)=NaN(40,1);
     irf_ect(:,co,2)=NaN(40,1);
     para_ect.l1.alpha(:,co)=NaN(2,1);  para_ect.l1.B(:,:,co)=NaN(2,2,1);  para_ect.l1.c1(:,co)=NaN(2,1);  para_ect.l1.cov(:,:,co)=NaN(2,2,1);
     para_ect.c0(co)=NaN(1,1);  para_ect.beta(:,co)=NaN(2,1);    para_ect.delta(:,co)=NaN(1,1);
     para_ect.l2.alpha(:,co)=NaN(2,1);  para_ect.l2.B(:,:,co)=NaN(2,4,1);  para_ect.l2.c1(:,co)=NaN(2,1);  para_ect.l2.cov(:,:,co)=NaN(2,2,1);
     para_ect.ll.alpha(:,co)=NaN(2,1);  para_ect.ll.B(:,:,co)=NaN(2,16,1);  para_ect.ll.c1(:,co)=NaN(2,1);  para_ect.ll.cov(:,:,co)=NaN(2,2,1);
    end
    
                   
           
end
   
    ISO_f=cellstr([ISO_f 'GME']);
    
    uni_hct=[uni_hct; NaN(1,2)]; bethcut=[bethcut; mean(bethcut,'omitnan')]; lag_uni_hct=[lag_uni_hct, NaN];  
    uni_ect=[uni_ect; NaN(1,2)]; betecut=[betecut; mean(betecut,'omitnan')]; lag_uni_ect=[lag_uni_ect, NaN];  
    
    hcp=[hcp; NaN(1,2)]; bethc=[bethc; mean(bethc,'omitnan')];   lag_hc=[lag_hc, NaN];
    ecp=[ecp; NaN(1,2)]; betec=[betec; mean(betec,'omitnan')];   lag_ec=[lag_ec, NaN];
    
    hcpt=[hcpt; NaN(1,2)]; bethct=[bethct; mean(bethct,'omitnan')]; lag_hct=[lag_hct, NaN];
    ecpt=[ecpt; NaN(1,2)]; betect=[betect; mean(betect,'omitnan')]; lag_ect=[lag_ect, NaN];   
    

   Coint_unitt=table(ISO_f',uni_hct(:,1),uni_hct(:,2),100*bethcut(:,1),bethcut(:,2),lag_uni_hct',uni_ect(:,1),uni_ect(:,2),100*betecut(:,1),betecut(:,2),lag_uni_ect');
   Coint_OLS=table(ISO_f',hcp(:,1),hcp(:,2),bethc(:,1),bethc(:,2),lag_hc',ecp(:,1),ecp(:,2),betec(:,1),betec(:,2),lag_ec');
   Coint_OLSr=table(ISO_f',hcpt(:,1),hcpt(:,2),100*bethct(:,1),bethct(:,2),bethct(:,3),lag_hct',ecpt(:,1),ecpt(:,2),100*betect(:,1),betect(:,2),betect(:,3),lag_ect');
 
    
    table2latex(Coint_unitt,'.\Tables\coint_unitt_pi_50p.tex')
    table2latex(Coint_OLS,'.\Tables\coint_OLS_pi_50p.tex')
    table2latex(Coint_OLSr,'.\Tables\coint_OLSt_pi_50p.tex')
    
    [h1] = irf_vecm(mean(para_hct_uni.c0,2,'omitnan'),mean(para_hct_uni.delta,2,'omitnan'),mean(para_hct_uni.beta,2,'omitnan'),...
    mean(para_hct_uni.ll.c1,2,'omitnan'),mean(para_hct_uni.ll.B,3,'omitnan'),...
    mean(para_hct_uni.ll.alpha,2,'omitnan'),mean(para_hct_uni.ll.cov,3,'omitnan'),0);


    [e1] = irf_vecm(mean(para_ect_uni.c0,2,'omitnan'),mean(para_ect_uni.delta,2,'omitnan'),mean(para_ect_uni.beta,2,'omitnan'),...
    mean(para_ect_uni.ll.c1,2,'omitnan'),mean(para_ect_uni.ll.B,3,'omitnan'),...
    mean(para_ect_uni.ll.alpha,2,'omitnan'),mean(para_ect_uni.ll.cov,3,'omitnan'),0);


figure; plot(e1(:,1,1)); hold on; plot(e1(:,1,2)); hold on; plot(h1(:,1,1)); hold on; plot(h1(:,1,2)); legend('infl_e','equity','infl_h','housing')

%figure; plot(e1_ger(:,1,1)); hold on; plot(e1_ger(:,1,2));  legend('infl_e','equity'); figure; plot(e2_ger(:,1,1)); hold on; plot(e2_ger(:,1,2));  legend('infl_e','equity');

       irf_pieq_pi=[(1:1:size(e1,1))' 100*e1(:,1,1)]; irf_eq_pi=[(1:1:size(e1,1))' 100*e1(:,1,2)];
       irf_pihs_pi=[(1:1:size(h1,1))' 100*h1(:,1,1)]; irf_hs_pi=[(1:1:size(h1,1))' 100*h1(:,1,2)];
        save .\Tables\irf_eq_pi_50p.dat irf_eq_pi  -ascii
        save .\Tables\irf_hs_pi_50p.dat irf_hs_pi  -ascii
        save .\Tables\irf_pieq_pi_50p.dat irf_pieq_pi  -ascii
        save .\Tables\irf_pihs_pi_50p.dat irf_pihs_pi  -ascii
 
%tab=table(ISO, Data);
