%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=1;

%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
prices_p_v=xlsread('JSTdatasetR6.xlsx',1,'AU2:AX2568'); 
prices_p_v=[prices_p_v(:,end), prices_p_v(:,1)];    
real_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AP2568');
%comp_assets=xlsread('JSTdatasetR4.xlsx',2,['AX' num2str(start+1) ':AX' num2str(ende)]);
nom_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AQ2:AR2568');
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[zeros((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
div_p_v=[xlsread('JSTdatasetR6.xlsx',1,'BD2:BD2568'), xlsread('JSTdatasetR6.xlsx',1,'AY2:AY2568')]; div_p_v=[zeros((size(CPI_v,1)-size(div_p_v,1)),2); div_p_v];
Hw_v=xlsread('JSTdatasetR6.xlsx',1,'BH2:BH2568')/1000;  Hw_v=[zeros((size(CPI_v,1)-size(Hw_v,1)),1); Hw_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);

%Create NxT(i) i=1,...,N Panel

for co=1:size(start)
    ISO=ISO_v(start(co));
    CPI=CPI_v(start(co):ende(co));
    real_assets=real_assets_v(start(co)+1:ende(co),:);
    nom_assets=nom_assets_v(start(co)+1:ende(co),:);
    rent_p=rent_p_v(start(co):ende(co),:);
  
    Hw=Hw_v(start(co)+1);

t=1:size(nom_assets,1);
%Data manipulation
%calculate inflation
CPI=CPI./CPI(1);
infl=CPI(2:end)./CPI(1:end-1)-1;

%create rents on housing price index  
inflH=rent_p(2:end,1)./rent_p(1:end-1,2)-1;

%calculate CPI w/o inflation 
inflxH=(infl-Hw*inflH)/(1-Hw);

for i=1:size(inflH)-5
    
    real_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    nom_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    
    inflxH5(i,:)=sum(inflxH(i:i+4,:))/5;
    infl5(i,:)=sum(infl(i:i+4,:))/5;
    inflH5(i,:)=sum(inflH(i:i+4,:))/5;

    
end

for i=1:size(inflH)-10
    
    real_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    nom_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    inflxH10(i,:)=sum(inflxH(i:i+9,:))/10;
    infl10(i,:)=sum(infl(i:i+9,:))/10;
    inflH10(i,:)=sum(inflH(i:i+9,:))/10;
   
    roll_corr10(i,2)=corr(real_assets(i:i+9,2),inflxH(i:i+9,:));
    roll_corr10(i,1)=corr(real_assets(i:i+9,1),inflxH(i:i+9,:));
    
end


Data=[real_assets infl inflxH];
Data5=[real_assets5 infl5 inflxH5];
Data10=[real_assets10 infl10 inflxH10];



if co==1
uPanel=[NaN(max(ende-start)-size(Data,1),size(Data,2)); Data];
uPanel5=[NaN(max(ende-start)-5-size(Data5,1),size(Data5,2)); Data5];
uPanel10=[NaN(max(ende-start)-10-size(Data10,1),size(Data10,2)); Data10];
else
uPanel=[uPanel; [NaN(max(ende-start)-size(Data,1),size(Data,2)); Data]];
uPanel5=[uPanel5; [NaN(max(ende-start)-5-size(Data5,1),size(Data5,2)); Data5]];
uPanel10=[uPanel10; [NaN(max(ende-start)-10-size(Data10,1),size(Data10,2)); Data10]];    
end


uPanel(any(isnan(uPanel),2),:) = NaN(size(uPanel(any(isnan(uPanel),2),:),1),size(Data,2));
uPanel5(any(isnan(uPanel5),2),:) =  NaN(size(uPanel5(any(isnan(uPanel5),2),:),1),size(Data5,2));
uPanel10(any(isnan(uPanel10),2),:) =  NaN(size(uPanel10(any(isnan(uPanel10),2),:),1),size(Data10,2));


Data(any(isnan(Data),2),:) = [];
Data5(any(isnan(Data5),2),:) = [];
Data10(any(isnan(Data10),2),:) = [];





if co==1
co_dum=zeros(size(Data,1), size(start,1)); co_dum(:,co)=ones(size(Data,1),1);
co_dum5=zeros(size(Data5,1), size(start,1)); co_dum5(:,co)=ones(size(Data5,1),1);
co_dum10=zeros(size(Data10,1), size(start,1)); co_dum10(:,co)=ones(size(Data10,1),1);
Panel=[Data co_dum];
Panel5=[Data5 co_dum5];
Panel10=[Data10 co_dum10];
else
co_dum=zeros(size(Data,1), size(start,1)); co_dum(:,co)=ones(size(Data,1),1);
co_dum5=zeros(size(Data5,1), size(start,1)); co_dum5(:,co)=ones(size(Data5,1),1);
co_dum10=zeros(size(Data10,1), size(start,1)); co_dum10(:,co)=ones(size(Data10,1),1);
Panel=[Panel; Data co_dum];
Panel5=[Panel5; Data5 co_dum5];
Panel10=[Panel10; Data10 co_dum10];    
end

clear real_assets5 nom_assets5 inflxH5 infl5 inflH5...
        real_assets10 nom_assets10 inflxH10 infl10 inflH10;
end


for i=0:15
    pi10(:,i+1)=uPanel10(i*size(uPanel10,1)/16+1:i*size(uPanel10,1)/16+size(uPanel10,1)/16,3);
end

% Baseline

    [be,~,re,~,ste]=regress(uPanel(:,1), [ones(size(uPanel(:,1))) uPanel(:,3)]);    
    [bh,~,rh,~,sth]=regress(uPanel(:,2), [ones(size(uPanel(:,1))) uPanel(:,3)]);
    

    [be5,~,re5,~,ste5]=regress(uPanel5(:,1), [ones(size(uPanel5(:,1))) uPanel5(:,3)]);     
    [bh5,~,rh5,~,sth5]=regress(uPanel5(:,2), [ones(size(uPanel5(:,1))) uPanel5(:,3)]);
    

    [be10,~,re10,~,ste10]=regress(uPanel10(:,1), [ones(size(uPanel10(:,1))) uPanel10(:,3)]);     
    [bh10,~,rh10,~,sth10]=regress(uPanel10(:,2), [ones(size(uPanel10(:,1))) uPanel10(:,3)]);
    
    
    bet_cov_eh=HACpan_siv(16, [ones(size(uPanel(:,1))) uPanel(:,3)],[re rh]);

    bet_cov_eh5=HACpan_siv(16, [ones(size(uPanel5(:,1))) uPanel5(:,3)],[re5 rh5]);
    
    bet_cov_eh10=HACpan_siv(16, [ones(size(uPanel10(:,1))) uPanel10(:,3)],[re10 rh10]);
    
    diffstat=([be(2) - bh(2)])./...
      sqrt([bet_cov_eh(2,2) + bet_cov_eh(4,4) - 2*bet_cov_eh(2,4)]);
  
    diffstat5=([be5(2) - bh5(2)])./...
      sqrt([bet_cov_eh5(2,2) + bet_cov_eh5(4,4) - 2*bet_cov_eh5(2,4)]);
  
    diffstat10=([be10(2) - bh10(2)])./...
      sqrt([bet_cov_eh10(2,2)+ bet_cov_eh10(4,4)- 2*bet_cov_eh10(2,4)]);
  
        p_diff=1-(tcdf(-diffstat,size(Panel,1)-1)+1-tcdf(1-diffstat,size(Panel,1)-1));
        
        p_diff5=1-(tcdf(-diffstat5,size(Panel5,1)-1)+1-tcdf(1-diffstat5,size(Panel5,1)-1));
        
        p_diff10=1-(tcdf(-diffstat10,size(Panel10,1)-1)+1-tcdf(1-diffstat10,size(Panel10,1)-1));


        
%Table beta_i std_beta_i R_adj 
    NT=size(Panel,1);
    NT5=size(Panel5,1);
    NT10=size(Panel10,1);
    Estats=[be(2) sqrt(bet_cov_eh(2,2)) 1-(1-ste(1))*(NT-1)/(NT-size(be,1)-2)];        
    Estats=round(Estats,2);
    Hstats=[bh(2) sqrt(bet_cov_eh(4,4)) 1-(1-sth(1))*(NT-1)/(NT-size(bh,1)-2)];        
    Hstats=round(Hstats,2);
    
    Estats5=[be5(2) sqrt(bet_cov_eh5(2,2)) 1-(1-ste5(1))*(NT-1)/(NT-size(be5,1)-2)];        
    Estats5=round(Estats5,2);
    Hstats5=[bh5(2) sqrt(bet_cov_eh5(4,4)) 1-(1-sth5(1))*(NT-1)/(NT-size(bh5,1)-2)];        
    Hstats5=round(Hstats5,2);
    
    Estats10=[be10(2) sqrt(bet_cov_eh10(2,2)) 1-(1-ste10(1))*(NT-1)/(NT-size(be10,1)-2)];        
    Estats10=round(Estats10,2);
    Hstats10=[bh10(2) sqrt(bet_cov_eh10(4,4)) 1-(1-sth10(1))*(NT-1)/(NT-size(bh10,1)-2)];        
    Hstats10=round(Hstats10,2);
  
  disp('Baseline');
  disp([' & ' num2str(Hstats(1)) ' & ' num2str(Hstats(2)) ' & ' num2str(Hstats(3)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff,2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT) '}' '\\']);
  disp([' & ' num2str(Estats(1)) ' & ' num2str(Estats(2)) ' & ' num2str(Estats(3))  ' & '  ' & ' '\\' ]);
  disp([' & ' num2str(Hstats5(1)) ' & ' num2str(Hstats5(2)) ' & ' num2str(Hstats5(3)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff5,2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT5) '}' '\\']);
  disp([' & ' num2str(Estats5(1)) ' & ' num2str(Estats5(2)) ' & ' num2str(Estats5(3))  ' & '  ' & ' '\\']);
  disp([' & ' num2str(Hstats10(1)) ' & ' num2str(Hstats10(2)) ' & ' num2str(Hstats10(3)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff10,2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT10) '}' '\\']);
  disp([' & ' num2str(Estats10(1)) ' & ' num2str(Estats10(2)) ' & ' num2str(Estats10(3)) ' & '  ' & ' '\\']);     
     
    BICe(1,:)=[NT*log(var(re,1,'omitnan')) NT5*log(var(re5,1,'omitnan')) NT10*log(var(re10,1,'omitnan'))]...
                +(1+size(be,1))*[log(NT) log(NT5) log(NT10)];
    BICh(1,:)=[NT*log(var(rh,1,'omitnan')) NT5*log(var(rh5,1,'omitnan')) NT10*log(var(rh10,1,'omitnan'))]...
                +(1+size(bh,1))*[log(NT) log(NT5) log(NT10)];
    
  
    
        
        
    % dummy d>1950
    uPanel=[uPanel, repmat(1:1:149,1,16)'];
    uPanel5=[uPanel5, repmat(1:1:144,1,16)'];
    uPanel10=[uPanel10, repmat(1:1:139,1,16)'];

    dum=zeros(16*144,1);
    dum5=zeros(16*139,1);
    dum10=zeros(16*134,1);

    dum(uPanel(:,end)>=79)=1;
    dum5(uPanel5(:,end)>=74)=1;
    dum10(uPanel10(:,end)>=69)=1;
    
    [be,~,re,~,ste]=regress(uPanel(:,1), [ones(size(uPanel(:,1))) uPanel(:,3) dum uPanel(:,3).*dum]);
    [bh,~,rh,~,sth]=regress(uPanel(:,2), [ones(size(uPanel(:,1))) uPanel(:,3) dum uPanel(:,3).*dum]);
    
    [be5,~,re5,~,ste5]=regress(uPanel5(:,1), [ones(size(uPanel5(:,1))) uPanel5(:,3) dum5 uPanel5(:,3).*dum5]);     
    [bh5,~,rh5,~,sth5]=regress(uPanel5(:,2), [ones(size(uPanel5(:,1))) uPanel5(:,3) dum5 uPanel5(:,3).*dum5]);
    
    [be10,~,re10,~,ste10]=regress(uPanel10(:,1), [ones(size(uPanel10(:,1))) uPanel10(:,3) dum10 uPanel10(:,3).*dum10]);     
    [bh10,~,rh10,~,sth10]=regress(uPanel10(:,2), [ones(size(uPanel10(:,1))) uPanel10(:,3) dum10 uPanel10(:,3).*dum10]);
    

    bet_cov_eh=HACpan_siv(16, [ones(size(uPanel(:,1))) uPanel(:,3) dum uPanel(:,3).*dum],[re rh]);

    bet_cov_eh5=HACpan_siv(16, [ones(size(uPanel5(:,1))) uPanel5(:,3) dum5 uPanel5(:,3).*dum5],[re5 rh5]);
    
    bet_cov_eh10=HACpan_siv(16, [ones(size(uPanel10(:,1))) uPanel10(:,3) dum10 uPanel10(:,3).*dum10],[re10 rh10]);
    
     diffstat=([be(2) - bh(2); be(4)+be(2) - bh(2)-bh(4); be(4); bh(4)])./...
          sqrt([bet_cov_eh(2,2) + bet_cov_eh(6,6) - 2*bet_cov_eh(2,6);...
          bet_cov_eh(2,2) + bet_cov_eh(4,4) + bet_cov_eh(6,6) + bet_cov_eh(8,8) ...
          + 2*bet_cov_eh(2,4) - 2*bet_cov_eh(2,6) - 2*bet_cov_eh(2,8) ...
          - 2*bet_cov_eh(4,6) - 2*bet_cov_eh(4,8) + 2*bet_cov_eh(6,8);...
          bet_cov_eh(4,4); bet_cov_eh(8,8)]);   
      
      p_diff=1-(tcdf(-diffstat,size(Panel,1)-1)+1-tcdf(1-diffstat,size(Panel,1)-1));
      
      diffstat5=([be5(2) - bh5(2); be5(4)+be5(2) - bh5(2)-bh5(4); be5(4); bh5(4)])./...
          sqrt([bet_cov_eh5(2,2) + bet_cov_eh5(6,6) - 2*bet_cov_eh5(2,6);...
          bet_cov_eh5(2,2) + bet_cov_eh5(4,4) + bet_cov_eh5(6,6) + bet_cov_eh5(8,8) ...
          + 2*bet_cov_eh5(2,4) - 2*bet_cov_eh5(2,6) - 2*bet_cov_eh5(2,8) ...
          - 2*bet_cov_eh5(4,6) - 2*bet_cov_eh5(4,8) + 2*bet_cov_eh5(6,8);...
          bet_cov_eh5(4,4); bet_cov_eh5(8,8)]);   

      p_diff5=1-(tcdf(-diffstat5,size(Panel5,1)-1)+1-tcdf(1-diffstat5,size(Panel5,1)-1));
      
      diffstat10=([be10(2) - bh10(2); be10(4)+be10(2) - bh10(2)-bh10(4); be10(4); bh10(4)])./...
          sqrt([bet_cov_eh10(2,2) + bet_cov_eh10(6,6) - 2*bet_cov_eh10(2,6);...
          bet_cov_eh10(2,2) + bet_cov_eh10(4,4) + bet_cov_eh10(6,6) + bet_cov_eh10(8,8) ...
          + 2*bet_cov_eh10(2,4) - 2*bet_cov_eh10(2,6) - 2*bet_cov_eh10(2,8) ...
          - 2*bet_cov_eh10(4,6) - 2*bet_cov_eh10(4,8) + 2*bet_cov_eh10(6,8);...
          bet_cov_eh10(4,4); bet_cov_eh10(8,8)]);   
      
      p_diff10=1-(tcdf(-diffstat10,size(Panel10,1)-1)+1-tcdf(1-diffstat10,size(Panel10,1)-1));
      
    Estats=[be(2) sqrt(bet_cov_eh(2,2)) be(2)+be(4) sqrt(bet_cov_eh(2,2)+bet_cov_eh(4,4)+2*bet_cov_eh(4,2))...
            p_diff(3) 1-(1-ste(1))*(NT-1)/(NT-size(be,1)-2)];        
    Estats=round(Estats,2);
    Hstats=[bh(2) sqrt(bet_cov_eh(6,6)) bh(2)+bh(4) sqrt(bet_cov_eh(6,6)+bet_cov_eh(8,8)+2*bet_cov_eh(6,8))...
            p_diff(4) 1-(1-sth(1))*(NT-1)/(NT-size(bh,1)-2)];        
    Hstats=round(Hstats,2);
    
    Estats5=[be5(2) sqrt(bet_cov_eh5(2,2)) be5(2)+be5(4) sqrt(bet_cov_eh5(2,2)+bet_cov_eh5(4,4)+2*bet_cov_eh5(4,2))...
            p_diff5(3) 1-(1-ste5(1))*(NT-1)/(NT-size(be5,1)-2)];        
    Estats5=round(Estats5,2);
    Hstats5=[bh5(2) sqrt(bet_cov_eh5(6,6)) bh5(2)+bh5(4) sqrt(bet_cov_eh5(6,6)+bet_cov_eh5(8,8)+2*bet_cov_eh5(6,8))...
            p_diff5(4) 1-(1-sth5(1))*(NT-1)/(NT-size(bh5,1)-2)];        
    Hstats5=round(Hstats5,2);
 
    Estats10=[be10(2) sqrt(bet_cov_eh10(2,2)) be10(2)+be10(4) sqrt(bet_cov_eh10(2,2)+bet_cov_eh10(4,4)+2*bet_cov_eh10(4,2))...
            p_diff10(3) 1-(1-ste10(1))*(NT-1)/(NT-size(be10,1)-2)];        
    Estats10=round(Estats10,2);
    Hstats10=[bh10(2) sqrt(bet_cov_eh10(6,6)) bh10(2)+bh10(4) sqrt(bet_cov_eh10(6,6)+bet_cov_eh10(8,8)+2*bet_cov_eh10(6,8))...
            p_diff10(4) 1-(1-sth10(1))*(NT-1)/(NT-size(bh10,1)-2)];        
    Hstats10=round(Hstats10,2);
     
  disp('Non-linear time');
  disp([' & ' num2str(Hstats(1)) ' & ' num2str(Hstats(2)) ' & ' num2str(Hstats(3)) ' & ' num2str(Hstats(4)) ' & ' num2str(Hstats(5)) ' & ' num2str(Hstats(6)) ' & '  '\multirow{2}{*}{' num2str(round(p_diff(1),2)) '}' ' & '  '\multirow{2}{*}{' num2str(round(p_diff(2),2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT) '}' '\\']);
  disp([' & ' num2str(Estats(1)) ' & ' num2str(Estats(2)) ' & ' num2str(Estats(3)) ' & ' num2str(Estats(4)) ' & ' num2str(Estats(5)) ' & ' num2str(Estats(6))  ' & ' ' & ' ' & ' '\\' ]);
  disp([' & ' num2str(Hstats5(1)) ' & ' num2str(Hstats5(2)) ' & ' num2str(Hstats5(3)) ' & ' num2str(Hstats5(4)) ' & ' num2str(Hstats5(5)) ' & ' num2str(Hstats5(6)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff5(1),2)) '}' ' & ' '\multirow{2}{*}{' num2str(round(p_diff5(2),2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT5) '}' '\\']);
  disp([' & ' num2str(Estats5(1)) ' & ' num2str(Estats5(2)) ' & ' num2str(Estats5(3)) ' & ' num2str(Estats5(4)) ' & ' num2str(Estats5(5)) ' & ' num2str(Estats5(6)) ' & ' ' & '  ' & ' '\\']);
  disp([' & ' num2str(Hstats10(1)) ' & ' num2str(Hstats10(2)) ' & ' num2str(Hstats10(3)) ' & ' num2str(Hstats10(4)) ' & ' num2str(Hstats10(5)) ' & ' num2str(Hstats10(6)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff10(1),2)) '}' ' & ' '\multirow{2}{*}{' num2str(round(p_diff10(2),2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT10) '}' '\\']);
  disp([' & ' num2str(Estats10(1)) ' & ' num2str(Estats10(2)) ' & ' num2str(Estats10(3)) ' & ' num2str(Estats10(4)) ' & ' num2str(Estats10(5)) ' & ' num2str(Estats10(6)) ' & ' ' & '  ' & ' '\\']);     
     
  
BICe(2,:)=[NT*log(var(re,1,'omitnan')) NT5*log(var(re5,1,'omitnan')) NT10*log(var(re10,1,'omitnan'))]...
                +(1+size(be,1))*[log(NT) log(NT5) log(NT10)];
BICh(2,:)=[NT*log(var(rh,1,'omitnan')) NT5*log(var(rh5,1,'omitnan')) NT10*log(var(rh10,1,'omitnan'))]...
                +(1+size(bh,1))*[log(NT) log(NT5) log(NT10)];
    
    
    %Rollin'
    for t=1:size(uPanel,1)/16-29
        use=uPanel;
        use(use(:,end)<t,:)=[];
        use(use(:,end)>t+29,:)=[];

        [be,test,re,~,ste]=regress(use(:,1), [ones(size(use(:,1))) use(:,3)]); 
        [bh,~,rh,~,sth]=regress(use(:,2), [ones(size(use(:,1))) use(:,3)]);
        bet_cov_eh=HACpan_siv(16, [ones(size(use(:,1))) use(:,3)],[re rh]);
        bet(t)=be(2);
        bht(t)=bh(2);

        bes(t)=bet_cov_eh(2,2);
        bhs(t)=bet_cov_eh(4,4);
        
        
        time(t)=1900+t;
    end

    roll=[bet; bet+1.96*bes; bet-1.96*bes; bht; bht+1.96*bhs; bht-1.96*bhs];
    
    roll=[time; roll]';
    
    
    for t=1:size(uPanel5,1)/16-29
        use=uPanel5;
        use(use(:,end)<t,:)=[];
        use(use(:,end)>t+29,:)=[];

        [be,test,re,~,ste]=regress(use(:,1), [ones(size(use(:,1))) use(:,3)]); 
        [bh,~,rh,~,sth]=regress(use(:,2), [ones(size(use(:,1))) use(:,3)]);
        bet_cov_eh=HACpan_siv(16, [ones(size(use(:,1))) use(:,3)],[re rh]);
        bet5(t)=be(2);
        bht5(t)=bh(2);

        bes5(t)=bet_cov_eh(2,2);
        bhs5(t)=bet_cov_eh(4,4);
        
        time5(t)=1905+t;
    end

    roll5=[bet5; bet5+1.96*bes5; bet5-1.96*bes5; bht5; bht5+1.96*bhs5; bht5-1.96*bhs5];
    roll5=[time5; roll5]';
    
    for t=1:size(uPanel10,1)/16-29
        use=uPanel10;
        use(use(:,end)<t,:)=[];
        use(use(:,end)>t+29,:)=[];

        [be,test,re,~,ste]=regress(use(:,1), [ones(size(use(:,1))) use(:,3)]); 
        [bh,~,rh,~,sth]=regress(use(:,2), [ones(size(use(:,1))) use(:,3)]);
        bet_cov_eh=HACpan_siv(16, [ones(size(use(:,1))) use(:,3)],[re rh]);
        bet10(t)=be(2);
        bht10(t)=bh(2);

        bes10(t)=bet_cov_eh(2,2);
        bhs10(t)=bet_cov_eh(4,4);

        time10(t)=1910+t;
    end
    roll10=[bet10; bet10+1.96*bes10; bet10-1.96*bes10; bht10; bht10+1.96*bhs10; bht10-1.96*bhs10];
    roll10=[time10; roll10]';
    

      
    %non-linear poly quad
    [be,~,re,~,ste]=regress(uPanel(:,1), [ones(size(uPanel(:,1))) uPanel(:,3) uPanel(:,3).^2 ]);
    [bh,~,rh,~,sth]=regress(uPanel(:,2), [ones(size(uPanel(:,1))) uPanel(:,3) uPanel(:,3).^2 ]);
    

    [be5,~,re5,~,ste5]=regress(uPanel5(:,1), [ones(size(uPanel5(:,1))) uPanel5(:,3) uPanel5(:,3).^2]);     
    [bh5,~,rh5,~,sth5]=regress(uPanel5(:,2), [ones(size(uPanel5(:,1))) uPanel5(:,3) uPanel5(:,3).^2]);
    

    [be10,~,re10,~,ste10]=regress(uPanel10(:,1), [ones(size(uPanel10(:,1))) uPanel10(:,3) uPanel10(:,3).^2]);    
    [bh10,~,rh10,~,sth10]=regress(uPanel10(:,2), [ones(size(uPanel10(:,1))) uPanel10(:,3) uPanel10(:,3).^2]);
    

    bet_cov_eh=HACpan_siv(16, [ones(size(uPanel(:,1))) uPanel(:,3) uPanel(:,3).^2 ],[re rh]);    
    bet_cov_eh5=HACpan_siv(16, [ones(size(uPanel5(:,1))) uPanel5(:,3) uPanel5(:,3).^2],[re5 rh5]);    
    bet_cov_eh10=HACpan_siv(16, [ones(size(uPanel10(:,1))) uPanel10(:,3) uPanel10(:,3).^2],[re10 rh10]);
    
    qadRqe=1-(1-ste(1))*(NT-1)/(NT-size(be,1)-2);
    qadRqh=1-(1-sth(1))*(NT-1)/(NT-size(bh,1)-2);
    qadRqe5=1-(1-ste5(1))*(NT5-1)/(NT5-size(be5,1)-2);
    qadRqh5=1-(1-sth5(1))*(NT5-1)/(NT5-size(bh5,1)-2);
    qadRqe10=1-(1-ste10(1))*(NT10-1)/(NT10-size(be10,1)-2);
    qadRqh10=1-(1-sth10(1))*(NT10-1)/(NT10-size(bh10,1)-2);
       
BICe(3,:)=[NT*log(var(re,1,'omitnan')) NT5*log(var(re5,1,'omitnan')) NT10*log(var(re10,1,'omitnan'))]...
                +(1+size(be,1))*[log(NT) log(NT5) log(NT10)];
BICh(3,:)=[NT*log(var(rh,1,'omitnan')) NT5*log(var(rh5,1,'omitnan')) NT10*log(var(rh10,1,'omitnan'))]...
                +(1+size(bh,1))*[log(NT) log(NT5) log(NT10)];
            
            
[histe,xe,ye]=histcounts2(uPanel(:,3), uPanel(:,1),'NumBins',[17 17],'XBinLimits',[prctile(uPanel(:,3),5) prctile(uPanel(:,3),95)],'YBinLimits',[prctile(uPanel(:,1),5) prctile(uPanel(:,1),95)],'Normalization','probability');
[histh,xh,yh]=histcounts2(uPanel(:,3), uPanel(:,2),'NumBins',[17 17],'XBinLimits',[prctile(uPanel(:,3),5) prctile(uPanel(:,3),95)],'YBinLimits',[prctile(uPanel(:,2),5) prctile(uPanel(:,2),95)],'Normalization','probability');
[histe5,xe5,ye5]=histcounts2(uPanel5(:,3), uPanel5(:,1),'NumBins',[17 17],'XBinLimits',[prctile(uPanel5(:,3),5) prctile(uPanel5(:,3),95)],'YBinLimits',[prctile(uPanel5(:,1),5) prctile(uPanel5(:,1),95)],'Normalization','probability');
[histh5,xh5,yh5]=histcounts2(uPanel5(:,3), uPanel5(:,2),'NumBins',[17 17],'XBinLimits',[prctile(uPanel5(:,3),5) prctile(uPanel5(:,3),95)],'YBinLimits',[prctile(uPanel5(:,2),5) prctile(uPanel5(:,2),95)],'Normalization','probability');
[histe10,xe10,ye10]=histcounts2(uPanel10(:,3), uPanel10(:,1),'NumBins',[17 17],'XBinLimits',[prctile(uPanel10(:,3),5) prctile(uPanel10(:,3),95)],'YBinLimits',[prctile(uPanel10(:,1),5) prctile(uPanel10(:,1),95)],'Normalization','probability');
[histh10,xh10,yh10]=histcounts2(uPanel10(:,3), uPanel10(:,2),'NumBins',[17 17],'XBinLimits',[prctile(uPanel10(:,3),5) prctile(uPanel10(:,3),95)],'YBinLimits',[prctile(uPanel10(:,2),5) prctile(uPanel10(:,2),95)],'Normalization','probability');

histe=histe(:);
[xe,ye]=ndgrid(movmean(xe,2,'Endpoints','discard')',movmean(ye,2,'Endpoints','discard')'); xe=xe(:); ye=ye(:); 
histe=[xe,ye,histe];
histh=histh(:);
[xh,yh]=ndgrid(movmean(xh,2,'Endpoints','discard')',movmean(yh,2,'Endpoints','discard')'); xh=xh(:); yh=yh(:); 
histh=[xh,yh,histh];

histe5=histe5(:);
[xe5,ye5]=ndgrid(movmean(xe5,2,'Endpoints','discard')',movmean(ye5,2,'Endpoints','discard')'); xe5=xe5(:); ye5=ye5(:); 
histe5=[xe5,ye5,histe5];
histh5=histh5(:);
[xh5,yh5]=ndgrid(movmean(xh5,2,'Endpoints','discard')',movmean(yh5,2,'Endpoints','discard')'); xh5=xh5(:); yh5=yh5(:); 
histh5=[xh5,yh5,histh5];

histe10=histe10(:);
[xe10,ye10]=ndgrid(movmean(xe10,2,'Endpoints','discard')',movmean(ye10,2,'Endpoints','discard')'); xe10=xe10(:); ye10=ye10(:); 
histe10=[xe10,ye10,histe10];
histh10=histh10(:);
[xh10,yh10]=ndgrid(movmean(xh10,2,'Endpoints','discard')',movmean(yh10,2,'Endpoints','discard')'); xh10=xh10(:); yh10=yh10(:); 
histh10=[xh10,yh10,histh10];


pref=strcat('roll');
save(['.\Tables\', pref, '.txt'],'roll','-ascii');
save(['.\Tables\', pref, '5.dat'],'roll5','-ascii');
save(['.\Tables\', pref, '10.dat'],'roll10','-ascii');

 pref=strcat('hist');
 save(['.\Tables\', pref, 'e.csv'],'histe','-ascii');
 save(['.\Tables\', pref, 'h.dat'],'histh','-ascii');
 save(['.\Tables\', pref, 'e5.dat'],'histe5','-ascii');
 save(['.\Tables\', pref, 'h5.dat'],'histh5','-ascii');
 save(['.\Tables\', pref, 'e10.dat'],'histe10','-ascii');
 save(['.\Tables\', pref, 'h10.dat'],'histh10','-ascii');
 