%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=0; ex_ger=1;


%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
HP_v=xlsread('JSTdatasetR6.xlsx',1,'AP2:AP2568'); HP_v=[NaN((size(CPI_v,1)-size(HP_v,1)),1); HP_v];
EP_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AO2568'); EP_v=[NaN((size(CPI_v,1)-size(EP_v,1)),1); EP_v];
HPP_v=xlsread('JSTdatasetR6.xlsx',1,'AU2:AU2568'); HPP_v=[NaN((size(CPI_v,1)-size(HPP_v,1)),1); HPP_v];
EPP_v=xlsread('JSTdatasetR6.xlsx',1,'AX2:AX2568'); EPP_v=[NaN((size(CPI_v,1)-size(EPP_v,1)),1); EPP_v];
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[NaN((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
div_p_v=[xlsread('JSTdatasetR6.xlsx',1,'BD2:BD2568'), xlsread('JSTdatasetR6.xlsx',1,'AY2:AY2568')]; div_p_v=[NaN((size(CPI_v,1)-size(div_p_v,1)),2); div_p_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);

HP_vec=0; EP_vec=0;
co_g=[1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 17];
for co=1:16
    stemp=co_g(co);
    ISO=ISO_v(1+size(CPI_v,1)/17*(stemp-1));
    CPI=[CPI_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp))];
    HP=log(1+[HP_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp)); 0]);
    EP=log(1+[EP_v(1+size(CPI_v,1)/17*(stemp-1):size(CPI_v,1)/17*(stemp)); 0]);
    
    nans=sum(isnan([HP EP]));

    
   
   
    
    
    time=1:size(CPI,1);
    
    for i=size(time,2):-1:2
        HP(i-1)=HP(i)-HP(i-1);
        EP(i-1)=EP(i)-EP(i-1);
    end
    
    if stemp==5
        EP(1:end-71)=NaN;
    end
    
    norm=max([find(~isnan(HP(2:end)),1), find(~isnan(EP(2:end)),1), find(~isnan(CPI),1)]');
    CPI(isnan(HP(1:end)) & isnan(EP(1:end)))= NaN;
    
    
    CP=log(CPI)-log(CPI(norm));
    HP=HP(2:end)-HP(norm+1);
    EP=EP(2:end)-EP(norm+1);
    Data=[CP HP EP];

         time=2021-size(Data,1):1:2020;
         figure
         plot(time,Data(:,1),'DisplayName','CP');
         hold on;plot(time,Data(:,2),'DisplayName','HP');
         hold on; plot(time,Data(:,3),'DisplayName','EP');
         hold off;
         legend
         title(ISO)
         Data=[time' Data];

         save(append('.\Tables\Data_',ISO,'.csv'), 'Data', '-ascii');
    
end    





