%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=0; ex_ger=1;

%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
prices_p_v=xlsread('JSTdatasetR6.xlsx',1,'AU2:AX2568'); 
prices_p_v=[prices_p_v(:,end), prices_p_v(:,1)];    
real_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AP2568');
%comp_assets=xlsread('JSTdatasetR4.xlsx',2,['AX' num2str(start+1) ':AX' num2str(ende)]);
nom_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AQ2:AR2568');
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[zeros((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
div_p_v=[xlsread('JSTdatasetR6.xlsx',1,'BD2:BD2568'), xlsread('JSTdatasetR6.xlsx',1,'AY2:AY2568')]; div_p_v=[zeros((size(CPI_v,1)-size(div_p_v,1)),2); div_p_v];
Hw_v=xlsread('JSTdatasetR6.xlsx',1,'BH2:BH2568')/1000;  Hw_v=[zeros((size(CPI_v,1)-size(Hw_v,1)),1); Hw_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);

HP_vec=0; EP_vec=0;

for co=1:size(start)
   ISO=ISO_v(start(co));
    CPI=CPI_v(start(co):ende(co));
    real_assets=real_assets_v(start(co)+1:ende(co),:);
    nom_assets=nom_assets_v(start(co)+1:ende(co),:);
    rent_p=rent_p_v(start(co):ende(co),:);
    Hw=Hw_v(start(co)+1);

t=1:size(nom_assets,1);
%Data manipulation
%calculate inflation
CPI=CPI./CPI(1);
infl=CPI(2:end)./CPI(1:end-1)-1;

Data=[real_assets infl];
Data_1 = Data;
   is_nan_row = any( isnan( Data ), 2 );
   is_inf_row = any( isinf( Data ), 2 );
   Data_1( (is_nan_row|is_inf_row), : ) = nan;
 Data=Data_1;
         time=2021-size(infl,1):1:2020;
         figure
         plot(time,Data(:,3),'DisplayName','CP');
         hold on;plot(time,Data(:,2),'DisplayName','HP');
         hold on; plot(time,Data(:,1),'DisplayName','EP');
         hold off;
         legend
         title(ISO)
         
         Data=[time' Data(:,3) Data(:,2) Data(:,1)];
         save(append('.\Tables\Data_dif_',ISO,'.csv'), 'Data', '-ascii');
end    





