%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
%Properties
plots=1;

%Start and Endpoints of the concerning country (+4*N -> update R6)
start=[33, 169+4, 449+4*3, 640+4*4, 738+4*5, 885+4*6, 1089+4*7, 1239+4*8, 1355+4*9, 1483+4*10, 1697+4*11, 1797+4*12, 1926+4*13, 2092+4*14, 2233+4*15, 2375+4*16]'-1;
ende=[147+5, 294+4+5, 588+4*3+5, 735+4*4+5, 882+4*5+5, 1029+4*6+5, 1176+4*7+5, 1323+4*8+5, 1470+4*9+5, 1617+4*10+5, 1764+4*11+5, 1911+4*12+5, 2058+4*13+5, 2205+4*14+5, 2352+4*15+5, 2499+4*16+5]'-1;

%Read data
CPI_v=xlsread('JSTdatasetR6.xlsx',1,'K2:K2568');
prices_p_v=xlsread('JSTdatasetR6.xlsx',1,'AU2:AX2568'); 
prices_p_v=[prices_p_v(:,end), prices_p_v(:,1)];    
real_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AO2:AP2568');
%comp_assets=xlsread('JSTdatasetR4.xlsx',2,['AX' num2str(start+1) ':AX' num2str(ende)]);
nom_assets_v=xlsread('JSTdatasetR6.xlsx',1,'AQ2:AR2568');
rent_p_v=xlsread('JSTdatasetR6.xlsx',1,'AV2:AW2568'); rent_p_v=[zeros((size(CPI_v,1)-size(rent_p_v,1)),2); rent_p_v];
div_p_v=[xlsread('JSTdatasetR6.xlsx',1,'BD2:BD2568'), xlsread('JSTdatasetR6.xlsx',1,'AY2:AY2568')]; div_p_v=[zeros((size(CPI_v,1)-size(div_p_v,1)),2); div_p_v];
Hw_v=xlsread('JSTdatasetR6.xlsx',1,'BH2:BH2568')/1000;  Hw_v=[zeros((size(CPI_v,1)-size(Hw_v,1)),1); Hw_v];
[~,ISO_v]=xlsread('JSTdatasetR6',1,'C2:C2568');
ISO_v=string(ISO_v);

%Create NxT(i) i=1,...,N Panel


for co=1:size(start)
    ISO=ISO_v(start(co));
    CPI=CPI_v(start(co):ende(co));
    real_assets=real_assets_v(start(co)+1:ende(co),:);
    nom_assets=nom_assets_v(start(co)+1:ende(co),:);
    rent_p=rent_p_v(start(co):ende(co),:);
    div_p=div_p_v(start(co):ende(co),:);
    price=prices_p_v(start(co)+1:ende(co),:);
    Hw=Hw_v(start(co)+1);

t=1:size(nom_assets,1);
%Data manipulation
%calculate inflation
CPI=CPI./CPI(1);
infl=CPI(2:end)./CPI(1:end-1)-1;
%price=price_p(2:end,:)./price_p(1:end-1,:)-1;
%Calculate inflation and create rents on housing price index
inflH=rent_p(2:end,1)./rent_p(1:end-1,2)-1;
div=div_p(2:end,1)./div_p(1:end-1,2)-1;
div(div==inf)=NaN;
%price(price==inf)=NaN;
%price(price==-inf)=NaN;
inflxH=(infl-Hw*inflH)/(1-Hw);

for i=1:size(inflH)-5
    
    real_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    nom_assets5(i,:)=sum(real_assets(i:i+4,:))/5;
    price5(i,:)=sum(price(i:i+4,:))/5;
    inflxH5(i,:)=sum(inflxH(i:i+4,:))/5;
    infl5(i,:)=sum(infl(i:i+4,:))/5;
    inflH5(i,:)=sum(inflH(i:i+4,:))/5;
    div5(i,:)=sum(div(i:i+4,:))/5;
    
end

for i=1:size(inflH)-10
    
    real_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    nom_assets10(i,:)=sum(real_assets(i:i+9,:))/10;
    price10(i,:)=sum(price(i:i+9,:))/10;
    inflxH10(i,:)=sum(inflxH(i:i+9,:))/10;
    infl10(i,:)=sum(infl(i:i+9,:))/10;
    inflH10(i,:)=sum(inflH(i:i+9,:))/10;
    div10(i,:)=sum(div(i:i+9,:))/10;
    roll_corr10(i,2)=corr(real_assets(i:i+9,2),inflxH(i:i+9,:));
    roll_corr10(i,1)=corr(real_assets(i:i+9,1),inflxH(i:i+9,:));
    
end


Data=[div inflH price inflxH];
Data5=[div5 inflH5 price5 inflxH5];
Data10=[div10 inflH10 price10 inflxH10];



if co==1
uPanel=[NaN(max(ende-start)-size(Data,1),size(Data,2)); Data];
uPanel5=[NaN(max(ende-start)-5-size(Data5,1),size(Data5,2)); Data5];
uPanel10=[NaN(max(ende-start)-10-size(Data10,1),size(Data10,2)); Data10];
else
uPanel=[uPanel; [NaN(max(ende-start)-size(Data,1),size(Data,2)); Data]];
uPanel5=[uPanel5; [NaN(max(ende-start)-5-size(Data5,1),size(Data5,2)); Data5]];
uPanel10=[uPanel10; [NaN(max(ende-start)-10-size(Data10,1),size(Data10,2)); Data10]];    
end


uPanel(any(isnan(uPanel),2),:) = NaN(size(uPanel(any(isnan(uPanel),2),:),1),size(Data,2));
uPanel5(any(isnan(uPanel5),2),:) =  NaN(size(uPanel5(any(isnan(uPanel5),2),:),1),size(Data5,2));
uPanel10(any(isnan(uPanel10),2),:) =  NaN(size(uPanel10(any(isnan(uPanel10),2),:),1),size(Data10,2));


Data(any(isnan(Data),2),:) = [];
Data5(any(isnan(Data5),2),:) = [];
Data10(any(isnan(Data10),2),:) = [];





if co==1
co_dum=zeros(size(Data,1), size(start,1)); co_dum(:,co)=ones(size(Data,1),1);
co_dum5=zeros(size(Data5,1), size(start,1)); co_dum5(:,co)=ones(size(Data5,1),1);
co_dum10=zeros(size(Data10,1), size(start,1)); co_dum10(:,co)=ones(size(Data10,1),1);
Panel=[Data co_dum];
Panel5=[Data5 co_dum5];
Panel10=[Data10 co_dum10];
else
co_dum=zeros(size(Data,1), size(start,1)); co_dum(:,co)=ones(size(Data,1),1);
co_dum5=zeros(size(Data5,1), size(start,1)); co_dum5(:,co)=ones(size(Data5,1),1);
co_dum10=zeros(size(Data10,1), size(start,1)); co_dum10(:,co)=ones(size(Data10,1),1);
Panel=[Panel; Data co_dum];
Panel5=[Panel5; Data5 co_dum5];
Panel10=[Panel10; Data10 co_dum10];    
end

clear real_assets5 nom_assets5 inflxH5 infl5 inflH5...
        real_assets10 nom_assets10 inflxH10 infl10 inflH10 div5 div10 price5 price10;
end


% rent/div

    [be,test,re,~,ste]=regress(uPanel(:,1), [ones(size(uPanel(:,1))) uPanel(:,5)]);    
    [bh,~,rh,~,sth]=regress(uPanel(:,2), [ones(size(uPanel(:,1))) uPanel(:,5)]);
    [bep,test,rep,~,step]=regress(uPanel(:,3), [ones(size(uPanel(:,1))) uPanel(:,5)]);    
    [bhp,~,rhp,~,sthp]=regress(uPanel(:,4), [ones(size(uPanel(:,1))) uPanel(:,5)]);
    
    bet_cov_eh=HACpan_siv(16, [ones(size(uPanel(:,5))) uPanel(:,5)],[re rh]);
    bet_cov_ehp=HACpan_siv(16, [ones(size(uPanel(:,5))) uPanel(:,5)],[rep rhp]);
    bet_cov_e=HACpan_siv(16, [ones(size(uPanel(:,5))) uPanel(:,5)],[re rep]);
    bet_cov_h=HACpan_siv(16, [ones(size(uPanel(:,5))) uPanel(:,5)],[rh rhp]);

    
    
  diffstat=([be(2) - bh(2)])./...
      sqrt([bet_cov_eh(2,2) + bet_cov_eh(4,4) - 2*bet_cov_eh(2,4)]);
  diffstatp=([bep(2) - bhp(2)])./...
      sqrt([bet_cov_ehp(2,2) + bet_cov_ehp(4,4) - 2*bet_cov_ehp(2,4)]);
  diffstate=([bep(2) - be(2)])./...
      sqrt([bet_cov_e(2,2) + bet_cov_e(4,4) - 2*bet_cov_e(2,4)]);
  diffstath=([bhp(2) - bh(2)])./...
      sqrt([bet_cov_h(2,2) + bet_cov_h(4,4) - 2*bet_cov_h(2,4)]);
  
  diffstat=[diffstat; diffstatp; diffstate; diffstath];
  p_diff=1-(tcdf(-diffstat,size(Panel,1)-1)+1-tcdf(1-diffstat,size(Panel,1)-1));
  
  
  
  % 5 MA
    [be5,test,re5,~,ste5]=regress(uPanel5(:,1), [ones(size(uPanel5(:,1))) uPanel5(:,5)]);    
    [bh5,~,rh5,~,sth5]=regress(uPanel5(:,2), [ones(size(uPanel5(:,1))) uPanel5(:,5)]);
    [bep5,test,rep5,~,step5]=regress(uPanel5(:,3), [ones(size(uPanel5(:,1))) uPanel5(:,5)]);    
    [bhp5,~,rhp5,~,sthp5]=regress(uPanel5(:,4), [ones(size(uPanel5(:,1))) uPanel5(:,5)]);
    
    bet_cov_eh5=HACpan_siv(16, [ones(size(uPanel5(:,5))) uPanel5(:,5)],[re5 rh5]);
    bet_cov_ehp5=HACpan_siv(16, [ones(size(uPanel5(:,5))) uPanel5(:,5)],[rep5 rhp5]);
    bet_cov_e5=HACpan_siv(16, [ones(size(uPanel5(:,5))) uPanel5(:,5)],[re5 rep5]);
    bet_cov_h5=HACpan_siv(16, [ones(size(uPanel5(:,5))) uPanel5(:,5)],[rh5 rhp5]);

    
    
  diffstat5=([be5(2) - bh5(2)])./...
      sqrt([bet_cov_eh5(2,2) + bet_cov_eh5(4,4) - 2*bet_cov_eh5(2,4)]);
  diffstatp5=([bep5(2) - bhp5(2)])./...
      sqrt([bet_cov_ehp5(2,2) + bet_cov_ehp5(4,4) - 2*bet_cov_ehp5(2,4)]);
  diffstate5=([bep5(2) - be5(2)])./...
      sqrt([bet_cov_e5(2,2) + bet_cov_e5(4,4) - 2*bet_cov_e5(2,4)]);
  diffstath5=([bhp5(2) - bh5(2)])./...
      sqrt([bet_cov_h5(2,2) + bet_cov_h5(4,4) - 2*bet_cov_h5(2,4)]);
  
  diffstat5=[diffstat5; diffstatp5; diffstate5; diffstath5];
  p_diff5=1-(tcdf(-diffstat5,size(Panel5,1)-1)+1-tcdf(1-diffstat5,size(Panel5,1)-1));
  
  
  %10
  
    [be10,test,re10,~,ste10]=regress(uPanel10(:,1), [ones(size(uPanel10(:,1))) uPanel10(:,5)]);    
    [bh10,~,rh10,~,sth10]=regress(uPanel10(:,2), [ones(size(uPanel10(:,1))) uPanel10(:,5)]);
    [bep10,test,rep10,~,step10]=regress(uPanel10(:,3), [ones(size(uPanel10(:,1))) uPanel10(:,5)]);    
    [bhp10,~,rhp10,~,sthp10]=regress(uPanel10(:,4), [ones(size(uPanel10(:,1))) uPanel10(:,5)]);
    
    bet_cov_eh10=HACpan_siv(16, [ones(size(uPanel10(:,5))) uPanel10(:,5)],[re10 rh10]);
    bet_cov_ehp10=HACpan_siv(16, [ones(size(uPanel10(:,5))) uPanel10(:,5)],[rep10 rhp10]);
    bet_cov_e10=HACpan_siv(16, [ones(size(uPanel10(:,5))) uPanel10(:,5)],[re10 rep10]);
    bet_cov_h10=HACpan_siv(16, [ones(size(uPanel10(:,5))) uPanel10(:,5)],[rh10 rhp10]);

    
    
  diffstat10=([be10(2) - bh10(2)])./...
      sqrt([bet_cov_eh10(2,2) + bet_cov_eh10(4,4) - 2*bet_cov_eh10(2,4)]);
  diffstatp10=([bep10(2) - bhp10(2)])./...
      sqrt([bet_cov_ehp10(2,2) + bet_cov_ehp10(4,4) - 2*bet_cov_ehp10(2,4)]);
  diffstate10=([bep10(2) - be10(2)])./...
      sqrt([bet_cov_e10(2,2) + bet_cov_e10(4,4) - 2*bet_cov_e10(2,4)]);
  diffstath10=([bhp10(2) - bh10(2)])./...
      sqrt([bet_cov_h10(2,2) + bet_cov_h10(4,4) - 2*bet_cov_h10(2,4)]);
  
  diffstat10=[diffstat10; diffstatp10; diffstate10; diffstath10];
  p_diff10=1-(tcdf(-diffstat10,size(Panel10,1)-1)+1-tcdf(1-diffstat10,size(Panel10,1)-1));
  
    NT=size(Panel,1);
    NT5=size(Panel5,1);
    NT10=size(Panel10,1);
  
    Estats=[be(2) sqrt(bet_cov_eh(2,2)) bep(2) sqrt(bet_cov_ehp(2,2))...
            p_diff(3) 1-(1-ste(1))*(NT-1)/(NT-size(be,1)-2) 1-(1-step(1))*(NT-1)/(NT-size(be,1)-2)];        
    Estats=round(Estats,2);
    Hstats=[bh(2) sqrt(bet_cov_eh(4,4)) bhp(2) sqrt(bet_cov_ehp(4,4))...
            p_diff(4) 1-(1-sth(1))*(NT-1)/(NT-size(bh,1)-2) 1-(1-sthp(1))*(NT-1)/(NT-size(bh,1)-2)];        
    Hstats=round(Hstats,2);
    
    Estats5=[be5(2) sqrt(bet_cov_eh5(2,2)) bep5(2) sqrt(bet_cov_ehp5(2,2))...
            p_diff5(3) 1-(1-ste5(1))*(NT5-1)/(NT5-size(be5,1)-2) 1-(1-step5(1))*(NT5-1)/(NT5-size(be5,1)-2)];        
    Estats5=round(Estats5,2);
    Hstats5=[bh5(2) sqrt(bet_cov_eh5(4,4)) bhp5(2) sqrt(bet_cov_ehp5(4,4))...
            p_diff5(4) 1-(1-sth5(1))*(NT5-1)/(NT5-size(bh5,1)-2) 1-(1-sthp5(1))*(NT5-1)/(NT5-size(bh5,1)-2)];        
    Hstats5=round(Hstats5,2);
    
    Estats10=[be10(2) sqrt(bet_cov_eh10(2,2)) bep10(2) sqrt(bet_cov_ehp10(2,2))...
                p_diff10(3) 1-(1-ste10(1))*(NT10-1)/(NT10-size(be10,1)-2) 1-(1-step10(1))*(NT10-1)/(NT10-size(be10,1)-2)];        
    Estats10=round(Estats10,2);
    Hstats10=[bh10(2) sqrt(bet_cov_eh10(4,4)) bhp10(2) sqrt(bet_cov_ehp10(4,4))...
                p_diff10(4) 1-(1-sth10(1))*(NT10-1)/(NT10-size(bh10,1)-2) 1-(1-sthp10(1))*(NT10-1)/(NT10-size(bh10,1)-2)];        
    Hstats10=round(Hstats10,2);
  
  disp([' & ' num2str(Hstats(1)) ' & ' num2str(Hstats(2)) ' & ' num2str(Hstats(3)) ' & ' num2str(Hstats(4)) ' & ' num2str(Hstats(5)) ' & ' num2str(Hstats(6))  ' & ' num2str(Hstats(7)) ' & '  '\multirow{2}{*}{' num2str(round(p_diff(1),2)) '}' ' & '  '\multirow{2}{*}{' num2str(round(p_diff(2),2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT) '}' '\\']);
  disp([' & ' num2str(Estats(1)) ' & ' num2str(Estats(2)) ' & ' num2str(Estats(3)) ' & ' num2str(Estats(4)) ' & ' num2str(Estats(5)) ' & ' num2str(Estats(6))  ' & ' num2str(Estats(7)) ' & ' ' & ' ' & ' '\\' ]);
  disp([' & ' num2str(Hstats5(1)) ' & ' num2str(Hstats5(2)) ' & ' num2str(Hstats5(3)) ' & ' num2str(Hstats5(4)) ' & ' num2str(Hstats5(5)) ' & ' num2str(Hstats5(6)) ' & ' num2str(Hstats5(7)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff5(1),2)) '}' ' & ' '\multirow{2}{*}{' num2str(round(p_diff5(2),2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT5) '}' '\\']);
  disp([' & ' num2str(Estats5(1)) ' & ' num2str(Estats5(2)) ' & ' num2str(Estats5(3)) ' & ' num2str(Estats5(4)) ' & ' num2str(Estats5(5)) ' & ' num2str(Estats5(6))  ' & ' num2str(Estats5(7)) ' & ' ' & '  ' & ' '\\']);
  disp([' & ' num2str(Hstats10(1)) ' & ' num2str(Hstats10(2)) ' & ' num2str(Hstats10(3)) ' & ' num2str(Hstats10(4)) ' & ' num2str(Hstats10(5)) ' & ' num2str(Hstats10(6)) ' & ' num2str(Hstats10(7)) ' & ' '\multirow{2}{*}{' num2str(round(p_diff10(1),2)) '}' ' & ' '\multirow{2}{*}{' num2str(round(p_diff10(2),2)) '}' ' & ' '\multirow{2}{*}{' num2str(NT10) '}' '\\']);
  disp([' & ' num2str(Estats10(1)) ' & ' num2str(Estats10(2)) ' & ' num2str(Estats10(3)) ' & ' num2str(Estats10(4)) ' & ' num2str(Estats10(5)) ' & ' num2str(Estats10(6)) ' & ' num2str(Estats10(7)) ' & ' ' & '  ' & ' '\\']); 
  