function [irf] = irf_vecm(c0,delta,beta,c1,B,alpha,Cov,plot)
%input c0, beta, delta -> cointegraton eq.
% c1, B alpha cov -> var eq.



if size(B,2)==2
Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{rot90(B,2)},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==4
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==6
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    B3=rot90(B(:,5:6),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2 B3},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==8
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    B3=rot90(B(:,5:6),2);
    B4=rot90(B(:,7:8),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2 B3 B4},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==10
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    B3=rot90(B(:,5:6),2);
    B4=rot90(B(:,7:8),2);
    B5=rot90(B(:,9:10),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2 B3 B4 B5},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==12
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    B3=rot90(B(:,5:6),2);
    B4=rot90(B(:,7:8),2);
    B5=rot90(B(:,9:10),2);
    B6=rot90(B(:,11:12),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2 B3 B4 B5 B6},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==14
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    B3=rot90(B(:,5:6),2);
    B4=rot90(B(:,7:8),2);
    B5=rot90(B(:,9:10),2);
    B6=rot90(B(:,11:12),2);
    B7=rot90(B(:,13:14),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2 B3 B4 B5 B6 B7},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
elseif size(B,2)==16
    B1=rot90(B(:,1:2),2);
    B2=rot90(B(:,3:4),2);
    B3=rot90(B(:,5:6),2);
    B4=rot90(B(:,7:8),2);
    B5=rot90(B(:,9:10),2);
    B6=rot90(B(:,11:12),2);
    B7=rot90(B(:,13:14),2);
    B8=rot90(B(:,15:16),2);
    Mdl = vecm('Adjustment',rot90(alpha,2),'Cointegration',rot90(beta,2),...
    'Constant',rot90(c1,2),'ShortRun',{B1 B2 B3 B4 B5 B6 B7 B8},'Covariance',rot90(Cov,2),'Trend',zeros(2,1));
end





Mdl.CointegrationConstant=c0;
if delta~=0
    Mdl.CointegrationTrend=delta;
end

VARMdl = varm(Mdl);
irf=armairf(VARMdl.AR,[],"InnovCov",VARMdl.Covariance,'Method','generalized',...
    "NumObs",100);

if plot==1
    armairf(VARMdl.AR,[],"InnovCov",VARMdl.Covariance,'Method','generalized',...
        "NumObs",40);
end




end

