function [alpha,B,c1,Cov] = vecm2(Y,beta,c0,delta,q)
%Enter egls coint and data of a 2 variable system-> output second stage of
%ecm estimation
%Y=Data, beta coint, c0 coint inter, delta coint trend, q -short run
%components

Y=rmmissing(Y);
[numObs,numDims] = size(Y);
tBase = (q+2):numObs;                    % Commensurate time base, all lags
T = length(tBase);                       % Effective sample size
YLags = lagmatrix(Y,0:(q+1));            % Y(t-k) on observed time base
LY = YLags(tBase,(numDims+1):2*numDims); % Y(t-1) on commensurate time base

DeltaYLags = zeros(T,(q+1)*numDims);
for k = 1:(q+1)
    DeltaYLags(:,((k-1)*numDims+1):k*numDims) = ...
               YLags(tBase,((k-1)*numDims+1):k*numDims) ...
             - YLags(tBase,(k*numDims+1):(k+1)*numDims);
end
 
DY = DeltaYLags(:,1:numDims);        % (1-L)Y(t)
DLY = DeltaYLags(:,(numDims+1):end); % [(1-L)Y(t-1),...,(1-L)Y(t-q)]

X = [(LY*beta-c0-tBase'*delta),DLY,ones(T,1)]; 
P = (X\DY)'; % [alpha,B1,...,Bq,c1]
alpha = P(:,1);
B = P(:,2:end-1);
c1 = P(:,end);

Cov=cov(DY-X*P');



end

